/*
 * macRingPrim.h --
 *
 *    Wei-ming Dai
 *
 *    It declares the operations to retrieve and update the attributes
 *    of routing ring.
 *
 * Copyright (C) 1988 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Head:$
 */

#ifndef _MAC_RING_PRIM
#define _MAC_RING_PRIM

extern BearId Mac_GetIdOfRing(/* ringPtr */);
/*
 * Ring    *ringPtr;
 */

extern BearStatus Mac_PutIdOfRing(/* id, ringPtr */);
/*
 * BearId  id;
 * Ring    *ringPtr;
 */

extern LinkedPoint * Mac_GetInBoundOfRing(/* ringPtr */);
/*
 * Ring    *ringPtr;
 */

extern LinkedPoint * Mac_GetOutBoundOfRing(/* ringPtr */);
/*
 * RingBound   boundary;
 */

extern Rect * Mac_GetInBBoxOfRing(/* ringPtr, boundary */);
/*
 * Ring        *ringPtr;
 * RingBound   boundary;
 */

extern void Mac_PutInBBoxOfRing(/* bboxPtr, boundary, ringPtr*/);
/*
 * Rect        *bboxPtr;
 * RingBound   boundary;
 * Ring        *ringPtr;
 */

extern Rect * Mac_GetOutBBoxOfRing(/* ringPtr, boundary */);
/*
 * Ring        *ringPtr;
 * RingBound   boundary;
 */

extern void Mac_PutOutBBoxOfRing(/* bboxPtr, boundary, ringPtr*/);
/*
 * Rect        *bboxPtr;
 * RingBound   boundary;
 * Ring        *ringPtr;
 */

extern Point * Mac_GetOriginOfRing(/* ringPtr */);
/*
 * Ring    *ringPtr;
 */

extern void Mac_PutOriginOfRing(/* originPtr, ringPtr */);
/*
 * Point   *originPtr;
 * Ring    *ringPtr;
 */

extern Transform * Mac_GetTransformOfRing(/* ringPtr */);
/*
 * Ring    *ringPtr;
 */

extern void Mac_PutTransformOfRing(/* transPtr, ringPtr */);
/*
 * Transform    *transPtr; 
 * Ring         *ringPtr;
 */

extern module * Mac_GetRModOfRing(/* ringPtr */);
/*
 * Ring    *ringPtr;
 */

extern void Mac_PutRModOfRing(/* rModPtr, ringPtr */);
/*
 * module    *rModPtr; 
 * Ring      *ringPtr;
 */

extern CellMaster * Mac_GetCellOfRing(/* ringPtr */);
/*
 * Ring    *ringPtr;
 */

extern char * Mac_GetCifFileNameOfRing(/* ringPtr */);
/*
 * Ring    *ringPtr;
 */

extern void Mac_PutCifFileNameOfRing(/* cifFileName, ringPtr */);
/*
 * char    *cifFileName; 
 * Ring    *ringPtr;
 */

extern int Mac_GetNumOfNetsOfRing(/* ringPtr */);
/*
 * Ring    *ringPtr;
 */

#endif _MAC_RING_PRIM
