/*
 * textio.h --
 *
 * Routines in the textio module
 *
 * Copyright (C) 1983 Regents of the University of California
 * All rights reserved.
 *
 * Needs:
 *	stdio.h
 *	sgtty.h   <--- NOTE!
 *	magic.h
 *
 * sccsid "@(#)textio.h	4.4 MAGIC (Berkeley) 11/2/85" 
 */

#define _TEXTIO

#ifndef _MAGIC
	err = Need_to_include_magic_header
#endif

/* printing procedures */
extern void TxPrintf();
extern void TxError();
extern void TxFlush();
extern void TxVisChar();
extern void TxUseMore();
extern void TxStopMore();

/* input procedures */
extern char *TxGetLinePrompt();
extern char *TxGetLine();
extern int TxGetChar();

/* prompting procedures */
extern void TxSetPrompt();
extern void TxPrompt();
extern void TxPromptOnNewLine();
extern void TxUnPrompt();
extern void TxRestorePrompt();
extern void TxReprint();

/* terminal-state procedures */
extern void TxSetTerminal();
extern void TxResetTerminal();
extern char TxEOFChar;			/* The current EOF character */
extern char TxInterruptChar;		/* The current interrupt character */

/* command procedures */
extern void TxDispatch();

/* variables that tell if stdin and stdout are to a terminal */
extern bool TxStdinIsatty;
extern bool TxStdoutIsatty;
#define TxInteractive	(TxStdinIsatty && TxStdoutIsatty)

/* Misc procs */
void TxInit();
