/*
 * Typescript Library - Header definitions
 *
 * David Harrison
 * University of California, Berkeley
 * 1988, 1990
 *
 * This is a library built on top of the AsciiText widget in the
 * Athena widget set that provides typescript capabilities.  It
 * opens a new top-level shell with an AsciiText widget in it.
 * The user supplies a callback function which is called when
 * any key is pressed in the window.  The package exports a function
 * for writing characters onto the end of the buffer of the typescript
 * window.  This function also supports deleting characters from
 * the end of the buffer.  Selection operations similar to those
 * found in xterm are supported.
 *
 * Initially,  this is not a formal subclass of asciiTextWidget.
 * Eventually,  I imagine it could be made into one.
 */

#ifndef _TYPESCRIPT_H_
#define _TYPESCRIPT_H_

#include "ansi.h"
#include <X11/Intrinsic.h>
#include <X11/Xaw/AsciiText.h>

typedef struct ts_call_data_defn {
    int len;			/* Length in bytes */
    char *buf;			/* Buffer          */
} ts_call_data;

extern Widget tsCreate
  ARGS((XtAppContext app, String name, Widget parent, Cardinal bufsize,
	XtCallbackProc callback, caddr_t client_data,
	ArgList args, Cardinal num_args));

extern int tsWriteChar
  ARGS((Widget w, int ch));

int tsWriteStr
  ARGS((Widget w, String str));

#endif /* _TYPESCRIPT_H_ */
