
/* bguCifPlotInt.h --
 *
 *     George Carvalho, Esq.
 *     (Advising Professor - E. S. Kuh)
 *
 * Copyright (C) 1987 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header$
 */

#ifndef BGU_CIFPLOTINT
#define BGU_CIFPLOTINT /* once-only latch */

#define BGU_CIF_LINE_SIZE 4096

#define MAXPOINTS 50         /* the maximum number of points in a polygon */
#define MAXDIGITS 80

#define BGU_BND0     01
#define BGU_BND1     02
#define BGU_BND2     04
#define BGU_NC      010
#define BGU_NP      020
#define BGU_NM      040
#define BGU_TRM    0100

/* ---------- Internal global variables for the cif plot code ---------- */

extern Rect         curCifBnd;
extern unsigned int curCifLayer;
extern short        npoints;
extern char         *progNamePtr;

extern Pixel
    curCifColor,
    BND0Color,
    BND1Color,
    BND2Color,
    NCColor,
    NPColor,
    NMColor,
    TRMColor;

/* ---------- Internal procedures for the cif plot code ---------- */

extern BearStatus BguSetUpCifColors();
extern BearStatus BguProcessLayer();

#endif /* BGU_CIFPLOTINT */

