
#ifndef DEQUE_EXPORT_H
#define DEQUE_EXPORT_H /* once-only latch */

typedef struct _Element Element;
struct _Element {
    ClientData  clientData;     /* The content node of the element */
    Element     *prevPtr;       /* The pointer to the prev element */
    Element     *nextPtr;       /* The pointer to the next element */
};

typedef struct _Deque Deque;
struct _Deque {
    Element *tail;  /* the tail of the deque */
};


/* ---------- External procedures ---------- */

extern Deque *MakeDeque();

extern void  DeleteDeque(/*deque*/);
/*
 * Deque *deque;
 */

extern int IsEmptyDeque(/*deque*/);
/*
 * Deque *deque;
 */

extern void PushDeque(/*deque, clientData*/);
/*
 * Deque       *deque;
 * ClientData  clientData;
 */

extern ClientData PopDeque(/*deque*/);
/*
 * Deque *deque;
 */

extern void InjectDeque(/*deque, clientData*/);
/*
 * Deque       *deque;
 * ClientData  clientData;
 */

extern ClientData EjectDeque(/*deque*/);
/*
 * Deque *deque;
 */

extern ClientData LookUpHead(/*deque*/);
/*
 * Deque *deque;
 */

extern ClientData LookUpTail(/*deque*/);
/*
 * Deque *deque;
 */

extern BearStatus ItrDeque(/*deque, func, clientData*/);
/*
 * Deque        *deque;
 * BearStatus  (*func)();
 * ClientData   clientData;
 */

#endif /* DEQUE_EXPORT_H */

