
/* fpgInt.h --
 *
 *     George Carvalho, Esq.
 *     Wei-ming Dai
 *     (Advising Professor - E. S. Kuh)
 *
 * Definitions internal to the fpg module.
 *
 * Copyright (C) 1986 Regents of the University of California
 * All rights reserved.
 *
 * Needs: fpg.h
 *
 * rcsid $Header: fpg.h,v 1.1 86/08/04 12:16:48 georgec Exp $
 */

#ifndef _FPG_INT
#define _FPG_INT


#define Bear_PrintFatalErr You_should_use_the_procedure_FpgPrintFatalErr instead


/* ---------- Internal procedures for the fpg module ---------- */

extern void FpgInsertWallSeg(/* NWJunct, SEJunct, segmentDir, segment */);
/*
 * WallJunction *NWJunct, *SEJunct;
 * SegmentDir   segmentDir;
 * WallSegment  *segment;
 */

extern void FpgPutBnLineOfWallSeg(/* bnLine, segment */);
/*
 * BNLine       *bnLine;
 * WallSegment  *segment;
 */

extern void FpgPutBnTileOfWallSeg(/* bnTile, segment */);
/*
 * Tile         *bnTile;
 * WallSegment  *segment;
 */

extern void FpgPutDegreeOfWallJunct(/* degree, junctPtr */);
/*
 * int          degree;
 * WallJunction *junctPtr;
 */

extern void FpgPutPointOfWallJunct(/* whichPoint, pointPtr, junctPtr */);
/*
 * int          whichPoint;
 * Point        *pointPtr;
 * WallJunction *junctPtr;
 */

extern void FpgPrintFatalErr(/* message */);
/*
 * BearString message;
 */

extern void FpgFreeRoom();

#endif _FPG_INT

