
#ifndef LR_SUB_NET
#define LR_SUB_NET

typedef struct subnet {
	struct subnet *subc; /*subnet chain within same net and module*/
	term *lefterm;	/*NULL if it is a junction*/
	term *righterm; /*NULL if it is a junction*/
	int lefthwidth1;
	int righthwidth1;
	int leftrdg;	/*-1 if lefterm is a junction*/
	int rightrdg;	/*-1 if righterm is a junction*/
	int loc1;	/*location of lefterm*/
	int loc2;	/*location of righterm*/
	int hwidth2;	/*wire width of this subnet*/
	int mark;
	int mark2;
	int priority;
	int span;	/*maxdensity span covered*/
	int parent;     /* weight of its longest ancestor chain */
	int parent2;	/* max of ancestor weight/density */
	int children;	/* weight of its longest descendent chain */
	int children2;	/* max of descendent weight/density */
	int maxdensity;
	int position;
	int indegree;	/*number of inedge's*/
	int outdegree;	/*number of outedge's*/
	struct edge *inedge;	/*edge directed to this subnet node*/
	struct edge *outedge; 	/*edge directed from this subnet node*/
} subnet;

typedef struct edge {
	subnet *from;
	subnet *to;
	int  dir;	/*0 for undirected edge*/
	int  weight;	/*minimum distance between two subnets*/
	int  worst;	/*channel width if wrong direction is assigned*/
	int  best;
	struct edge *inedge;	/*edge chain which point to terminal "to"*/
	struct edge *outedge;	/*edge chain which point from terminal "from"*/
	struct edge *undiredge;/*undirected edge chain*/
	struct edge *diredge;  /*  directed edge chain*/
} edge;

typedef struct dragon {
	struct dragon *succ;
	term *subtc;	/*terminal chain within same net and module*/
	subnet *subc;	/*subnet   chain within same net and module*/
} dragon;

struct subloc {
	subnet *subp;
	int loc;
	int width;
	};

struct termchain {
	term *trm;
	Signal *sig;
	int loc1;
	int loc2;
	struct termchain *next;
	};

#endif LR_SUB_NET

