
/* localViaInt.h --
 *
 *     Xiao-Ming Xiong
 *     (Professor E. S. Kuh)
 *
 * Copyright (C) 1987 Regents of the University of California
 * All rights reserved.
 *
 * needs: localRouter.h
 * 
 * rcsid $Header$
 */

#ifndef _LOCAL_VIA_INT
#define _LOCAL_VIA_INT

typedef struct via_node via_node;

#define SUCCESS     0
#define FAILED      -1
#define HORI        0
#define VERT        1
#define CROSS       0
#define FREE_RUN    1
#define DIE         22

int num_vias;
int red_vias;

struct via_node {
    int         flag;           /* type of the node:
                                 *    HORI
                                 *    VERT
                                 */
    int         vias;           /* number of vias incidented
                                 * by this segment
                                 */
    int         status;         /* status of the node:
                                 *    CROSS
                                 *    FREE_RUN
                                 */
    int         degree;         /* number of segments
                                 * intersect
                                 */
    locxy       coord1, coord2;
    root        *hsr;
    via_node    *nextnode;      /* pointer to the next
                                 * node in the node list
                                 */
    via_node    *crossnode;     /* pointer to the next
                                 * node cross this node
                                 */
    struct rseg *segment;       /* pointer to actual routing
                                 * segment in the database
                                 */
};

struct via_h_list {
    int         num_nodes;
    via_node    *h_node;
} via_h_list;

struct via_v_list {
    int         num_nodes;
    via_node    *v_node;
} via_v_list;

extern via_node *via_add_node( /* seg */ );
/*
struct rseg *seg;   pointer to the routing segment in the node
*/

#endif _LOCAL_VIA_INT

