
/* macInt.h --
 *
 *      June Wang
 *      (Professor E. S. Kuh)
 *
 * This file contains the declaration of internally used global
 * variables and procedures.
 *
 * Copyright (C) 1986 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header: macInt.h,v 1.1 87/02/04 14:05:37 weiming Exp $
 */

#ifndef _MAC_INT
#define _MAC_INT

#ifndef _BEAR
int err1 = Need_to_include_bear_header;
#endif _BEAR


#define Bear_PrintFatalErr You_should_use_the_procedure_MacPrintFatalErr instead


/* ---------- Internal global variables for the mac module ---------- */

extern BearId               macCurrentId;   


/* ---------- Internal procedures for the mac module ---------- */

extern void MacCreateHashTables();

extern PortMaster *MacMakePortMaster();
extern PortInst *MacMakePortInst();

extern BearStatus MacFindEndOfCellGroup(/* linkedCellPtr, endCellPtr */);
/*
 *  LinkedCell  *lnkedCellPtr, *endCellPtr; 
 */  

extern BearStatus MacChangeCellGroupPtr(/* linkedCellPtr, cellGroupPtr */);
/*
 *  LinkedCell  *linkedCellPtr;
 *  CellGroup   *cellGroupPtr;
 */

extern BearStatus MacCountNumOfCells(/* cellPtr, numPtr */);
/*
 * CellInst  *cellPtr;
 * int  *numPtr;
 */

extern BearStatus MacCountNumOfNets(/* netPtr, numPtr */);
/*
 * Net  *netPtr;
 * int  *numPtr;
 */

extern BearStatus  MacCountNumOfPorts(/* portPtr, numPtr */);
/*
 * PortInst  *portPtr;
 * int  *numPtr;
 */

extern BearStatus  MacCountNumOfPins(/* pinPtr, numPtr */);
/*
 * PinInst  *pinPtr;
 * int  *numPtr;
 */

extern void MacMakeTechData();

extern void MacPrintFatalErr();

#endif _MAC_INT

