
/* macPinPrim.h --
 *
 *      June Wang
 *      (Prof. E. S. Kuh)
 *
 * It declares all the operations for retrieving and updating the 
 * information stored in pins.
 *
 * Copyright (C) 1986 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header: macPinPrim.h,v 1.1 87/02/04 14:05:54 weiming Exp $
 */

#ifndef _MAC_PIN_PRIM
#define _MAC_PIN_PRIM /* once-only latch */

/* ---------- Pin Primitives ---------- */

extern BearString Mac_GetNameOfPinMaster(/* pinMasterPtr */); 
/*
 * PinMaster *pinMasterPtr;
 */
  
extern BearStatus Mac_PutNameOfPinMaster(/* name, pinMasterPtr */); 
/*
 * BearString    name;
 * PinMaster     *pinMasterPtr;
 */
  
EXTERN BearId Mac_GetIdOfPinInst
    ARGS((PinInst *pinInstPtr));
  
EXTERN BearString Mac_GetNameOfPinInst
    ARGS((PinInst *pinInstPtr));

EXTERN BearStatus Mac_PutNameOfPinInst
    ARGS((BearString pinInstName, PinInst *pinInstPtr));

extern bool Mac_IsFixedPin(/* pinInstPtr */);  
/*
 * PinInst *pinInstPtr;
 */

extern Flexibility Mac_GetFlexOfPin(/* pinInstPtr */);
/*
 * PinInst *pinInstPtr;
 */

extern void Mac_PutFlexOfPin(/* flexType, pinInstPtr */);
/*
 * Flexibility  flexType;
 * PinInst      *pinInstPtr;
 */

extern void Mac_PutPinPosDefFlag(/* posDefFlag, pinInstPtr */);
/*
 * bool         posDefFlag;
 * PinInst      *pinInstPtr;
 */

extern bool Mac_IsPinPosDef(/* pinInstPtr */);
/*
 * PinInst      *pinInstPtr;
 */

extern Point *Mac_GetRelPosOfPin(/*pinInst*/);
/*
 *  PinInst *pinInst;
 */

extern void Mac_PutRelPosOfPin(/*relPos, pinInst*/);
/*
 *  Point   *relPos;
 *  PinInst *pinInst;
 */

extern LayerVector Mac_GetLayerofPin(/*pinInstPtr*/);
/*
 *  PinInst   *pinInstPtr;
 */

extern void Mac_PutLayerOfPin(/*layer, pinInstPtr*/);
/*
 *  int layer;
 *  PinInst   *pinInstPtr;
 */

extern void Mac_GetAbsPosOfPin(/*pinInst, absPos*/);
/*
 *  PinInst *pinInst;
 *  Point   *absPos;
 */

extern LinkedSegID *Mac_GetPosConstrOfCell (/*pinInst*/);
/*
 *  PinInst *pinInst;
 */

extern PinDirection Mac_GetDirectionOfPin(/* pinInstPtr */);
/*
 *  PinInst  *pinInstPtr;
 */

extern void Mac_PutDirectionOfPin(/* pinDir, pinInstPtr */);
/*
 * PinDirection    pinDir;
 * PinInst         *pinInstPtr;
 */

extern PinMaster *Mac_GetMasterOfPin(/*inst*/);
/*
 * PinInst *inst;
 */

extern PinInst *Mac_GetPrevPin(/*pin*/);
/*
 * PinInst *pin;
 */

extern PinInst *Mac_GetNextPin(/*pin*/);
/*
 * PinInst *pin;
 */

extern float Mac_GetPinWidthOfPin(/*pinInst*/);
/*
 * PinInst  *pinInst;
 */

extern void Mac_PutPinWidthOfPin(/*pinWidth, pinInst*/);
/*
 * float    pinWidth;
 * PinInst  *pinInst;
 */

extern float Mac_GetSegmWidthOfPin(/*pinInst*/);
/*
 * PinInst  *pinInst;
 */

extern void Mac_PutSegmWidthOfPin(/*segmWidth, pinInst*/);
/*
 * float    segmWidth;
 * PinInst  *pinInst;
 */

extern float * Mac_GetWidthVectOfPin(/* pinInstPtr */);
/* 
 * PinInst  *pinInstPtr;
 */

extern void Mac_PutWidthVectOfPin(/* widthVect, pinInstPtr */);
/* 
 * float    *widthVect;
 * PinInst  *pinInstPtr;
 */

extern PortInst *Mac_GetPortOfPin(/* pinInst */);
/*
 * PinInst *pinInst;
 */

extern Net *Mac_GetNetOfPin(/* pinInst */);
/*
 * PinInst *pinInst;
 */

extern BearStatus Mac_NumOfPinsOfPort(/*portPtr, numPtr*/);
/*
 *  PortInst  *portPtr;
 *  int   *numPtr;
 */

extern BearString  Mac_GetNetNameOfPin(/*pinPtr*/);
/*
 *  PinInst *pinPtr;
 */

extern void  Mac_PutNetNameOfPin(/*namePtr, pinPtr*/);
/*
 *  BearString  namePtr;
 *  PinInst     *pinPtr;
 */

extern BearId Mac_GetIntNetIdOfPin(/*pinPtr*/);
/*
 *  PinInst *pinPtr;
 */

extern void Mac_PutIntNetIdOfPin(/*id, pinPtr*/);
/*
 *  BearId  id;
 *  PinInst *pinPtr;
 */

extern BearId Mac_GetExtNetIdOfPin(/*pinPtr*/);
/*
 *  PinInst *pinPtr;
 */

extern void  Mac_PutExtNetIdOfPin(/*id, pinPtr*/);
/*
 *  BearId  id;
 *  PinInst *pinPtr;
 */

extern BearId Mac_GetHExtNetIdOfPin(/*pinPtr*/);
/*
 *  PinInst *pinPtr;
 */

extern void Mac_PutHExtNetIdOfPin(/*id, pinPtr*/);
/*
 *  BearId  id;
 *  PinInst *pinPtr;
 */

extern BearId Mac_GetVExtNetIdOfPin(/*pinPtr*/);
/*
 *  PinInst     *pinPtr;
 */

extern void Mac_PutVExtNetIdOfPin(/*id, pinPtr*/);
/*
 *  BearId  id;
 *  PinInst *pinPtr;
 */

extern PinKind Mac_GetKindOfPin(/* pinPtr */);
/*
 *  PinInst *pinPtr;
 */

extern void Mac_PutKindOfPin(/* pinKind, pinPtr */);
/*
 *  PinKind pinKind;
 *  PinInst *pinPtr;
 */

#endif _MAC_PIN_PRIM

