
/* macPortPrim.h --
 *
 *      June Wang
 *      Wei-ming Dai
 *      (Prof. E. S. Kuh)
 *
 * It declares the operations to retrieve and update the information
 * in ports.
 *
 * Copyright(C) 1986 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header: macPortPrim.h,v 1.1 87/02/04 14:06:02 weiming Exp $
 */

#ifndef _MAC_PORT_PRIM
#define _MAC_PORT_PRIM

/* ---------- Port Primitives ---------- */

extern BearString Mac_GetNameOfPortMaster(/*portMaster*/);
/*
 * PortMaster *portMaster;
 */

extern BearStatus Mac_PutNameOfPortMaster(/*name, PortMaster*/);
/*
 * BearString name;
 * PortMaster     *portMaster;
 */

extern BearString Mac_GetNameOfPortInst(/*portInst*/);
/*
 * PortInst *portInst;
 */

extern BearStatus Mac_PutNameOfPortInst(/*name, portInst*/);
/*
 * BearString name;
 * PortInst       *portInst;
 */

extern PortKind Mac_GetKindOfPort(/*portInst*/);
/*
 * PortInst *portInst;
 */

extern void Mac_PutKindOfPort(/*kind, portInst*/);
/*
 * PortKind kind;
 * PortInst *portInst;
 */

extern PortDir Mac_GetDirectionOfPort(/*portInst*/);
/*
 * PortInst *portInst;
 */

extern void Mac_PutDirectionOfPort(/*direction, portInst*/);
/*
 * PortDir  direction;
 * PortInst *portInst;
 */

extern MinNomMax Mac_GetDCFanInLoadOfPort(/*portInst*/);
/*
 * PortInst *portInst;
 */

extern void Mac_PutDCFanInLoadOfPort(/*DCFanInLoad, portInst*/);
/*
 * MinNomMax DCFanInLoad;
 * PortInst  *portInst;
 */

extern MinNomMax Mac_GetDCFanOutLoadOfPort(/*portInst*/);
/*
 * PortInst *portInst;
 */

extern void Mac_PutDCFanOutLoadOfPort(/*DCFanOutLoad, portInst*/);
/*
 * MinNomMax DCFanOutLoad;
 * PortInst  *portInst;
 */

extern MinNomMax Mac_GetDCMaxFanInOfPort(/*portInst*/);
/*
 * PortInst *portInst;
 */

extern void Mac_PutDCMaxFanInOfPort(/*DCMaxFanIn, portInst*/);
/*
 * MinNomMax DCMaxFanIn;
 * PortInst  *portInst;
 */

extern MinNomMax Mac_GetDCMaxFanOutOfPort(/*portInst*/);
/*
 * PortInst *portInst;
 */

extern void Mac_PutDCMaxFanOutOfPort(/*DCMaxFanOut, portInst*/);
/*
 * MinNomMax DCMaxFanOut;
 * PortInst  *portInst;
 */

extern MinNomMax Mac_GetACLoadOfPort(/*portInst*/);
/*
 * PortInst *portInst;
 */

extern void Mac_PutACLoadOfPort(/*ACLoad, portInst*/);
/*
 * MinNomMax ACLoad;
 * PortInst  *portInst;
 */

extern double Mac_GetMaxVoltDropOfPort(/*portInst*/);
/*
 * PortInst *portInst;
 */

extern void Mac_PutMaxVoltDropOfPort(/*maxVoltDrop, portInst*/);
/*
 * double    maxVoltDrop;
 * PortInst  *portInst;
 */

extern double Mac_GetMaxCurrentReqOfPort(/*portInst*/);
/*
 * PortInst *portInst;
 */

extern void Mac_PutMaxCurrentReqOfPort(/*maxCurrentReq, portInst*/);
/*
 * double    macCurrentReq;
 * PortInst  *portInst;
 */

extern LinkedPort *Mac_GetEleEqvOfPort(/* portInst */);
/*
 * PortInst *portInst;
 */

extern LinkedPort *Mac_GetFeedThrOfPort(/* portInstPtr */);
/*
 * PortInst *portInstPtr;
 */

extern PortMaster *Mac_GetMasterOfPort(/* portInstPtr */);
/*
 * PortInst *portInstPtr;
 */

extern CellInst *Mac_GetCellInstOfPort(/* portInstPtr */);
/*
 * PortInst *portInstPtr;
 */

extern Net *Mac_GetNetOfPort(/* portInstPtr */);
/*
 * PortInst *portInstPtr;
 */

extern BearStatus Mac_NumOfPortsOfCell(/*cellInstPtr, numPtr*/);
/*
 *  CellInst *cellInstPtr;
 *  int  *numPtr;
 */

extern BearStatus Mac_NumOfPortsOfNet(/*netPtr, numPtr*/);
/*
 *  Net  *netPtr;
 *  int  *numPtr;
 */

extern PinInst *Mac_GetAssignedPinOfPort(/* portPtr */);
/*
 *  PortInst  *portPtr;
 */

extern BearStatus Mac_IsPortMarked(/*portPtr*/);
/*
 *  PortInst  *portPtr;
 */

extern void Mac_UnmarkPort(/*portPtr*/);
/*
 *  PortInst  *portPtr;
 */

extern void Mac_MarkPort(/*portPtr*/);
/*
 *  PortInst  *portPtr;
 */

#endif _MAC_PORT_PRIM

