
/* nclDatabase.h --
 *
 *    Bernhard Eschermann
 *    (Advising Professor - E. S. Kuh)
 *
 *    This file has to be included with clusterInp.c. It contains the type
 *    definitions necessary for the functions that help in iterating the
 *    BEAR database entries.
 *
 * Copyright (C) 1987 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header$
 */

#ifndef _CLBTYPE_H
#define _CLBTYPE_H /* once-only latch */



/* ---------- Structure definitions and constants ---------- */


typedef struct _NodeInfo {
    int         number;
    GraphNode   *nodePtr;
} NodeInfo;

typedef struct _EdgeInfo {
    int         number;
    GraphEdge   *edgeList;
    CellInst    *coreInst;
    Ncl_LinkedCritNet **critNetListPtr;
} EdgeInfo;

typedef struct _PortInfo {
    int         numOfEdges;
    double      weight;
    double      weight2;
    GraphEdge   *edgeList;
    CellInst    *coreInst;
    GraphNode   **nodeOfPortList;
    GraphNode   **currentPtr;
    PinDirection *pinOfPortList;
    PinDirection *currentPin;
    Ncl_LinkedCritNet **critNetListPtr;
} PortInfo;

#endif _CLBTYPE_H


