
/* nclMacros.h --
 *
 *    Bernhard Eschermann
 *    (Advising Professor - E. S. Kuh)
 *
 *    Contains the definition of internal procedures and macros for the
 *    clustering module. Also defines some internal constants.
 *
 * Copyright (C) 1987 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header$
 */

#ifndef _CLUSTER_MAC_H
#define _CLUSTER_MAC_H /* once-only latch */



/* ------------ Declarations for internal procedures ------------- */
extern void NclPrintFatalErr(/* errorCode */);
/* 
 * int errorCode;
 */


/* ------------ Declarations for internal macros ------------- */
#define SWAP(type, x, y)    \
    {                       \
        type temp = (x);    \
        (x) = (y);          \
        (y) = temp;         \
    }

#define TIMES100(x) ((int) (100 * (x) + 0.5))
#define DIVIDE100(x) ((float) (0.01 * (x)))
#define NEXT(ptr) (ptr = (ptr)->nextPtr)


/*
 * ----------------------------------------------------------------------------
 *
 * GetStorMc() -- (macro)
 *
 *  Allocates 'amount' storage positions for 'type' and makes
 *  it accessible by 'pointer'.
 *
 * ----------------------------------------------------------------------------
 */

#define GetStorMc(pointer, amount, type)                                   \
{                                                                          \
    MALLOC(type *, pointer, (amount) * sizeof (type));                     \
}


#define ClusterSizeMc(nodePtr) ((nodePtr)->belongsToPtr->gn_numOfChildren)

#define ArrayPosMc(el, array)           \
{                                       \
    int i;                              \
    for (i = 0; i < MAX_CHILDREN; i++)  \
    {                                   \
        if ((array)[i] == (el))         \
        {                               \
            pos = i;                    \
            break;                      \
        }                               \
    }                                   \
}



#endif _CLUSTER_MAC_H


