
#ifndef _RDB_TRANS
#define _RDB_TRANS

typedef enum _RModRotateKind
{
    H_TO_V,    /* Transform a straight channel from horizontal to vertical */
    V_TO_H,    /* Transform a straight channel from vertical to horizontal */
    TL_TO_TR,  /* Transform an L-shaped channel from TL to TR */
    TR_TO_TL,  /* Transform an L-shaped channel from TR to TL */
    BL_TO_TR,  /* Transform an L-shaped channel from BL to TR */
    TR_TO_BL,  /* Transform an L-shaped channel from TR to BL */
    BR_TO_TR,  /* Transform an L-shaped channel from BR to TR */
    TR_TO_BR   /* Transform an L-shaped channel from TR to BR */
} RModRotateKind;

extern void Rdb_TransBndOfRMod(/* modPtr, transPtr */);
/*
 * module    *modPtr;
 * Transform *transPtr;
 */

extern BearStatus Rdb_TransRTerm(/* rTermPtr, transPtr */);
/*
 * term      *rTermPtr;
 * Transform *transPtr;
 */

extern BearStatus Rdb_TransRJunct(/* rJunctPtr, transPtr*/);
/* 
 * rjun      *rJunctPtr;
 * Transform *transPtr;
 */

extern BearStatus Rdb_TransRSegm(/* rSegmPtr, transPtr */);
/* 
 * rseg      *rSegmPtr;
 * Transform *transPtr;
 */

extern void Rdb_ComputeVToHTrans(/* transPtr */);
/*
 * Transform *transPtr;
 */

extern void Rdb_ComputeHToVTrans(/* transPtr */);
/* 
 * Transform *transPtr;
 */

extern void Rdb_ComputeTLToTRTrans(/* transPtr */);
/* 
 * Transform *transPtr;
 */

extern void Rdb_ComputeTRToTLTrans(/* transPtr */);
/* 
 * Transform *transPtr;
 */

extern void Rdb_ComputeBLToTRTrans(/* transPtr */);
/* 
 * Transform *transPtr;
 */

extern void Rdb_ComputeTRToBLTrans(/* transPtr */);
/* 
 * Transform *transPtr;
 */

extern void Rdb_ComputeBRToTRTrans(/* transPtr */);
/* 
 * Transform *transPtr;
 */

extern void Rdb_ComputeTRToBRTrans(/* transPtr */);
/* 
 * Transform *transPtr;
 */

extern void Rdb_RotateRMod(/* rotateKind, rModPtr */);
/*
 * RModRotateKind rotateKind;
 * module         *rModPtr;
 */

extern void Rdb_TranslateRMod(/* x, y, rModPtr */);
/*
 * int		 x;
 * int		 y;
 * module        *rModPtr;
 */

extern void Rdb_TransRMod(/* transPtr, rModPtr */);
/*
 * Transform 	 *transPtr;
 * module        *rModPtr;
 */

#endif _RDB_TRANS

