/*
 * textioInt.h --
 *
 * INTERNAL definitions for the textio module
 *
 * Copyright (C) 1983 Regents of the University of California
 * All rights reserved.
 *
 *
 * sccsid "@(#)textioInt.h	4.2 MAGIC (Berkeley) 8/26/85" 
 */

#define _TEXTIOINT

#ifndef _MAGIC
	err = Need_to_include_magic_header
#endif
#ifndef _TEXTIO
	err = Need_to_include_textio_header
#endif
#ifndef _TXCOMMANDS
	err = Need_to_include_txcommands_header
#endif

extern bool txHavePrompt;

typedef struct {
    int tx_fdmask;		/* A mask of the file descriptors for this 
				 * device.
				 */
    Void (*tx_inputProc)(); 	/* A procedure that fetches events and stores
				 * them in the input queue via TxAddEvent().
				 */
    ClientData tx_cdata;	/* Data to be passed back to caller. */
} txInputDevRec;

/* Maximum number of open files per process.  Must be 32 or less. */
#define	TX_MAX_OPEN_FILES	20

#define TX_PROMPT	'>'
#define TX_LONG_CMD	':'	/* Way of invoking a long command. */
#define TX_LONG_CMD2	';'	/* Alternate way of invoking a long command. */

#include <sgtty.h>

/* all of the state associated with a tty terminal */
typedef struct {
    struct sgttyb tx_i_sgtty;
    struct tchars tx_i_tchars;
} txTermState;

extern void TxGetInputEvent();
