/*
 * magic.h --
 *
 * Global definitions for all MAGIC modules
 *
 * Copyright (C) 1983 Regents of the University of California
 * All rights reserved.
 *
 * Needs to include <stdio.h> and <sys/types.h>
 *
 * sccsid @(#)magic.h   4.3 MAGIC (Berkeley) 8/5/85
 */

#ifndef _MAGIC
#define _MAGIC

#include "clientData.h"

/* --------------------------- Booleans ------------------------------- */

#define bool int

#ifndef TRUE
#define TRUE    1
#define FALSE   0
#endif /* TRUE */

/* ------------ Function headers of globally used functions ----------- */

extern char *strcpy(), *strncpy(), *index(), *rindex();
extern char *strcat(), *strncat();


/* --------------------- Debugging and assertions --------------------- */

#ifdef  PARANOID
#define ASSERT(p, where) \
    ((!(p)) \
    ? (sprintf(AbortMessage, "%s botched: %s\n",  \
        where, "p"), \
    fputs(AbortMessage, stderr), \
    niceabort(), \
    TRUE) \
    : FALSE)
#else
#define ASSERT(p, where)    (FALSE)
#endif  PARANOID

/* ------------------------ Malloc/free ------------------------------- */

/*
 * Magic has its own versions of malloc() and free(), called mallocMagic()
 * and freeMagic().  Magic procedures should ONLY use these procedures.
 * Just for the sake of robustness, though, we define malloc and free
 * here to error strings.
 */

/*
 * code change : by george : on  2 nov 89
 *
#define malloc  You_should_use_the_Magic_procedure_mallocMagic instead
#define free    You_should_use_the_Magic_procedure_freeMagic instead
#define calloc  You_should_use_the_Magic_procedure_callocMagic instead
 */

#define mallocMagic malloc
#define freeMagic   free
#define callocMagic calloc

/* ---------- Flag for global variables (for readability) ------------- */
/*        Also a Void type, which is like void except that we   */
/*        can declare pointers to functions that return it.         */

#define global  /* Nothing */
#define Void    int

/* ------------ Globally-used strings. -------------------------------- */

extern char AbortMessage[];

extern char *StrDup();

#endif _MAGIC

