.nr PD 0v
.ls 2
.ds RH 29 September 1989
.rm CH 
.ds CF - % -
.P1
.LP
.sp 5
.ce 
\fBThe Official BBL File Format for the BEAR System\fR
.sp 2
.PP
Below is a complete description of the BBL format 
for a routing file which must be named something.r.
The smallest description allowed is a root module with no terminals.
.PP
We encourage users to check the validity of there BBL files by
using the -bblc option when opening a window with the 
\fBow\fR
command.
.sp 1
.XP
\fI1.) Rules for describing a module and terminals.\fR
.br
a. Only rectangular modules are allowed.
.br
b. The spacing between any two adjacent modules must be wide enough
to allow one signal wire to pass between them.
.br
c. The coordinates of the modules
corners must each be on a separate line of the input file 
in counter-clockwise order.
.br
d. Every terminal must lie on a boundary of a module.
.br
e. No terminal may lie on a corner of a module.
.br
f. No two terminals may have the same coordinates.
.br
.LP
\fI2.) The overall format for a BBL file.\fR
.br
\fBSN\fR <number of nets> <nl>
.br
< root module >
.br
[ < one or more child modules > ]
.br
\fB$\fR
.br
.LP
\fI3.) The format for a single module of the BBL file.\fR
.br
.ls 1
\fBMOD\fR <nl>
.br
<ox> <oy> [ <mt> ] <nl>
.br
<module name> <nl>
.br
<module type> <nl>
.br
<cx1> <cy1> <nl>
.br
<cx2> <cy2> <nl>
.br
<cx3> <cy3> <nl>
.br
<cx4> <cy4> <nl>
.br
\fB$\fR <nl>
.br
\fBT\fR <nl>
.br
[ <tx> <ty> <net name> <routing direction> <terminal type> <nl> ]
.br
   .       .
.br
   .       .
.br
\fB$\fR <nl>
.br
.sp 1
.ls 2
.LP
\fI4.) Detailed description of a routing files syntax.\fR
.PP
Please note that
information enclosed in braces [ ] above is optional.
Also all numbers are expected to be integers, and finally no blank
lines are permitted.
.sp 1
.XP
\fBMOD\fR This is a marker that indicates the begining of a module.
.XP
\fBSN\fR This marker must be the first thing in the file.
.XP
\fBT\fR This is a marker that indicates the begining of a terminal list.
It must always be present, i.e. even if there aren't any terminals.
.XP
\fB$\fR This is a marker that indicates the end of a particular group of data.
Two of them in a row indicates the end of the file.
.XP
<nl> The new line character is used to terminate each line.  Simply type
a carriage return when inputing the file.
.XP
<ox> <oy> This is the modules origin, which all of the coordinates in
the module are relative to.
The origin of a child module is relative to the root module.
.XP
<cxi> <cyi> A pair of coordinates indicating a corner of the module.
.XP
<tx> <ty> A pair of coordinates relative to the module's origin indicating
the position of the terminal.
.XP
<net name> The name of the net that the terminal belongs to.  It may
be up to 40 characters.
.XP
<number of nets> The total number of nets.
.XP
<mt> Optional module transformation which is applied to all of the modules
coordinates. 0, 3, 4, and 5 are legal values as follows:
.br
.ls 1
0 - Identity Transform
.br
3 - Transform module by 90 degrees
.br
4 - Transform module by 180 degrees
.br
5 - Transform module by 270 degrees
.br
.sp 1
.ls 2
.XP
<module type> The type of the module. 1 and 0 are legal values as follows:
.br
.ls 1
1 : for the root module
.br
0 : for the other modules
.br
.sp 1
.ls 2
.XP
<terminal type> The type of terminal. At the moment 2 is the only legal
value, and it indicates that the terminal is fixed in place.  In 
the future the number of terminal types will be expanded.
.XP
<routing direction> The routing direction of the terminal. 0, 1, 2, and 3
are legal values as follows:
.br
.ls 1
0 - Pin is on WEST side of module.
.br
1 - Pin is on SOUTH side of module.
.br
2 - Pin is on EAST side of module.
.br
3 - Pin is on NORTH side of module.
.br
.sp 1
.ls 2
.LP
\fI5.) Sample BBL file.\fR
.PP
A copy of this file may be found 
in /users/bear/bear/src/polarBear/bearData/bblSample.r
.ls 1
\fC
SN 2
.br
MOD
.br
0 0
.br
bound
.br
1
.br
1000 1000
.br
0 1000
.br
0 0
.br
1000 0
.br
$
.br
T
.br
133 1000 net1 1 2 
.br
$
.br
MOD
.br
133 542
.br
Mickey
.br
0
.br
411 306
.br
0 306
.br
0 0
.br
411 0
.br
$
.br
T
.br
411 190 net2 2 2 
.br
0 128 net2 0 2 
.br
411 54 net1 2 2 
.br
$
.br
MOD
.br
703 145
.br
Donald
.br
0
.br
146 510
.br
0 510
.br
0 0
.br
146 0
.br
$
.br
T
.br
76 0 net1 1 2 
.br
0 91 net2 0 2 
.br
$
.br
MOD
.br
183 202
.br
Goofy
.br
0
.br
240 247
.br
0 247
.br
0 0
.br
240 0
.br
$
.br
T
.br
0 143 net1 0 2 
.br
202 0 net2 1 2 
.br
$
.br
$
.br
