
/* bearMain.c --
 *
 *     George Carvalho, Esq.
 *     (Advising Professor - E. S. Kuh)
 *
 */

#ifndef lint
static char rcsid[] = "$Header$";
#endif  not lint

#include "bearCopyRight.h"
#include "port.h"
#include "utility.h"
#include "magic.h"
#include "geometry.h"
#include "bear.h"
#include "bearPathnames.h"


/* ---------- Declarations of external procedures ---------- */
extern int          util_csystem();
extern char         *util_strsav();


/* ---------- External global variables for the bearMisc module ---------- */
FILE *bearout;
FILE *bearerr;
char bear_ErrorMsg[BEAR_MSG_SIZE];
char bear_Msg[BEAR_MSG_SIZE];
bool bear_BlackBoxFlag;

char *bear_tmpDir;


BearStatus
Bear_Begin()
{
    bearout = stdout;
    bearerr = stderr;

    bear_BlackBoxFlag = FALSE;

#ifdef MM_H
    bear_mm_FreeTwiceFlag = FALSE;
#endif MM_H

    bear_tmpDir = util_strsav(util_tilde_expand(BEAR_TMP_DIR));

    return (BEAR_OK);
}



void
Bear_Print(msg)
BearString msg;
{
    (void) fprintf (bearout, "%s: %s\n", BEAR_PROG_NAME, msg);
    (void) fflush (bearout);
}


void
Bear_PrintWarn(warnMsg)
BearString warnMsg;
{
    (void) fprintf (bearout, "%s: Warning: %s\n", BEAR_PROG_NAME, warnMsg);
    (void) fflush (bearout);
}


void
Bear_PrintErr(errMsg)
BearString errMsg;
{
    (void) fprintf (bearerr, "%s: Error: %s\n", BEAR_PROG_NAME, errMsg);
}


void
Bear_PrintFatalErr(fatalErrMsg)
BearString fatalErrMsg;
{
    errRaise(BEAR_PROG_NAME, ((int) -1), fatalErrMsg);
}


char *
Bear_GetBooleanString(value)
bool value;
{
    return (value ? "TRUE" : "FALSE");
}


/*
 * ----------------------------------------------------------------------------
 *
 * Bear_Pause() --
 *
 * Waits for you to type either c (continue), e (exit) or a (abort)
 * followed by return or just plain return before going on.
 *
 * Results:
 *   None.
 *
 * Side effects:
 *   None.
 * ----------------------------------------------------------------------------
 */

void
Bear_Pause()
{
    char letter[10];

    fprintf (bearerr,
        "Type 'c' to continue, 'e' to exit, 'a' to abort: [c] ");
    scanf ("%1s", letter);
    switch (letter[0]) {
    case 'a':
        abort ();
        break;
    case 'c':
        break;
    case 'e':
    case 'q':
        exit (-1);
        break;
    default:
        break;
    }
}



void
Bear_RemoveTmpFiles()
{
#ifndef DEBUG
    sprintf (bear_Msg, "rm -f %s %s  %s %s  %s %s  %s %s  %s %s\n",
        "bear.ring.cif",
        "breaklong.debug",

        "bound_master.ring",
        "deb.debug",

        "glitter.debug",
        "glitter.input",

        "modhori.bbl",
        "modvert.bbl",

        "proc_master.ring",
        "side3.debug");

    system (bear_Msg);
#endif DEBUG
}



/*
 * The magic code seems to need the following stuff.
 */

int SigInterruptPending;

MainExit(status)
int status;
{
    exit (status);
}


