
/* cpaInterface.h --
 *
 *     George Carvalho, Esq.
 *     (Advising Professor - E. S. Kuh)
 *
 * Copyright (C) 1991 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header$
 */

#ifndef CPA_INTERFACE_EXPORT_H
#define CPA_INTERFACE_EXPORT_H /* once-only latch */

#include "ansi.h"

typedef struct _Cpa_ArrPinData Cpa_ArrPinData;
struct _Cpa_ArrPinData {
    char    *cpaProgPtr;        /* can have '~' */
    char    *tmpDirPtr;         /* can have '~' */
    bool    saveFlag;           /* Flag indicating whether or not the
                                 * temporary directory should be saved.
                                 */
    bool    warnFlag;
};

/* ---------- External procedures for the cpa module ---------- */

EXTERN BearStatus Cpa_ArrPinsForOneBnTile
    ARGS((CellMaster *coreMasterPtr, Tile *bnTilePtr, 
        Cpa_ArrPinData *optDataPtr));

EXTERN BearStatus Cpa_ArrPinsForAllBnTiles
    ARGS((CellMaster *coreMasterPtr, Cpa_ArrPinData *optDataPtr));

#endif /* CPA_INTERFACE_EXPORT_H */

