
/* geoChDecomposer.h --
 *
 *     (Advising Professor - E. S. Kuh)
 *
 * Copyright (C) 1989 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header$
 */

#ifndef _GEO_CH_DECOMPOSER
#define _GEO_CH_DECOMPOSER

extern BearStatus Gcd_DefineHorzBound(/* planeDataPtr, lJunctPtr, rJunctPtr, 
    domTilePtr, routeCellPtr  */);
/*
 * PlaneData    *planeDataPtr; 
 * WallJunction *lJunctPtr;
 * WallJunction *rJunctPtr;
 * Tile         *domTilePtr;
 * RouteCell    *routeCellPtr;
 */

extern BearStatus Gcd_DefineVertBound(/* planeDataPtr, tJunctPtr, bJunctPtr, 
                         domTilePtr, routeCellPtr  */);
/*
 * PlaneData    *planeDataPtr; 
 * WallJunction *tJunctPtr;
 * WallJunction *bJunctPtr;
 * Tile         *domTilePtr;
 * RouteCell    *routeCellPtr;
 */

extern BearStatus Gcd_DefineTopRightLBound(/* parentCellPtr, rJunctPtr, 
    mJunctPtr, tJunctPtr, horzDomTilePtr, vertDomTilePtr, rCellPtrPtr */);
/*
 * CellMaster   *parentCellPtr;
 * WallJunction *rJunctPtr;
 * WallJunction *mJunctPtr;
 * WallJunction *tJunctPtr;
 * Tile         *horzDomTilePtr;
 * Tile         *vertDomTilePtr;
 * RouteCell    **rCellPtrPtr;
 */

extern void Gcd_DefineSidePin(/* planeDataPtr,junctPtr,rCellPtr,sideDir */);
/*
 * PlaneData     *planeDataPtr;
 * WallJunction  *junctPtr;
 * RouteCell     *rCellPtr;
 * SideDirection sideDir;
 */

extern void Gcd_UpdateSidePinOfRCell(/* rCellPtr */);
/*
 * RouteCell     *rCellPtr;
 */

extern void Gcd_DefineBoundPin(/* planeDataPtr,rCellPtr */);
/*
 * PlaneData     *planeDataPtr;
 * RouteCell     *rCellPtr;
 */

extern void Gcd_DefineFeedThru(/* pinPtr, rCellPtr */);

/*
 * PinInst         *pinPtr;
 * RouteCell       *rCellPtr;
 */

extern void Gcd_DefineRing(/* parentCellPtr*/);
/*
 * CellMaster    *parentCellPtr;
 */


/* ------- External global variables for the geoChDecomposer module ------- */
extern bool gcd_DebugFlag;


#endif _GEO_CH_DECOMPOSER

