
#include "grInt.h"

void 
Gr_PushDownwardPartitionedNodes(kPtr,sNet)
grRegion *kPtr;
grSubNet *sNet;
/*
   Results : none.
   superNodes of sNet which currently sit at kPtr level are pushed
   to subregions. In general sNet has 2 superNodes and
   the function is used in case when internal blockages are detected
   and pull-mechanism is applied.

              NO PREROUTED NET VERSION                               
 */
{
    grDeadRegion   *dead;
    grSubNet       *newNet;
    grSuperNode    *left ,*right;
    grPinRectangle *newDownL, *newUpR, *current;
    float           total;
    int             vtp,htp,xpos,ypos;


    right=NULL;
    left=NULL;
    current=NULL;

    if (sNet->NodeList==NULL)
    {
        return;
    }

    if (sNet->NodeList->side==1)
    {
        left=sNet->NodeList;
        right=sNet->NodeList->nextOnList;
    }
    else
    {
        right=sNet->NodeList;
        left=right->nextOnList;
    }

    dead=grHeadDeadRegion;
    
    while(dead!=NULL)
    {
        if (dead->side==0)  /* left side */
        {
            current=left->contentsPtr;
        }
        else
        {
            current=right->contentsPtr;
        }
        
        if (current!=NULL)
        {
            if (Gr_IsPinRectangleFullyContainedInDeadRegion(
            current,dead,kPtr->dir)==1)
            {
            /*Createa new pinRectangle and copy the current
              to it. The new one will be eventually dropped
              down.
            */
            newDownL=Gr_AllocateMemoryForNewPinRectangle();
            Gr_CopyPinRectangle(current,newDownL);
            current=NULL;
            }
            else
            {
            if (Gr_PinRectangleInDeadRegion(current,dead,kPtr->dir)
            ==1)
            {
                /*
                Create two pinRectangles,split the current.
                */
                newUpR=Gr_AllocateMemoryForNewPinRectangle();
                newDownL=Gr_AllocateMemoryForNewPinRectangle();
                if (kPtr->dir==1)
                {
                    /*
                    Main cut was vertical,pinRectangle
                    is sliced horizontally.
                    */
                    ypos=dead->ytop;
                    Gr_YHardSplitPinRectangle(ypos,
                    current,newUpR,newDownL);
                    current=newUpR;
                }
                else
                {

                    /*
                    Main cut was horizontal,pinRectangle
                    is sliced vertically.
                    */
                    xpos=dead->xright;
                    Gr_XHardSplitPinRectangle(xpos,
                    current,newDownL,newUpR);
                    current=newUpR;
                }
            }
            else
            {
                /*
                Do nothing, take next dead region.
                */
                goto lab1;
            }
        }
        /*
        Put newDownL on a linked list.
        */
        if (dead->region->firstPinRectanglePtr==NULL)
        {
            dead->region->firstPinRectanglePtr=newDownL;
            dead->region->lastPinRectanglePtr=newDownL;
            newDownL->nextOnList=NULL;
        }
        else
        {
            newDownL->nextOnList=dead->region->
            firstPinRectanglePtr;
            dead->region->firstPinRectanglePtr=newDownL;
        }
        /*
        Create new subNet in dead->region.
        */
        Gr_CreateNewSubnet(dead->region);
        newNet=dead->region->subNetsPtr;
        newNet->netname=sNet->netname;
        newNet->subname=Gr_GetNewSubNetName();
        newNet->decCandidate = sNet->decCandidate;
        newNet->xapprox=sNet->xapprox;
        newNet->yapprox=sNet->yapprox;
        newNet->active=0;
        newNet->noComponents=0;
        newNet->toBeConnected=newDownL;
        newNet->critical = sNet->critical;
        newNet->noLoosePins=newDownL->count;
        
        Gr_SetBoundBox(newNet);

        if (gr_Timing == 1) /* all nets lengths calculated*/
        {
            htp=Gr_CalculateHorizontalPortionOfTree(newDownL);
            vtp=Gr_CalculateVerticalPortionOfTree(newDownL);
            total=htp+vtp*gr_HorVertWire;
            newNet->approxLength=total;
            ((gr_HeadGrNets+sNet->netname)->currentLength)+=
            total;
            ((gr_HeadGrNets+sNet->netname)->xapprox)+=
                         htp;
            ((gr_HeadGrNets+sNet->netname)->yapprox)+=
                         vtp;
            newNet->xapprox=htp;
            newNet->yapprox=vtp;
        }


        if (dead->side==0)  /*left side*/
        {
            left->contentsPtr=current;
        }
        else
        {
            right->contentsPtr=current;
        }
        }
        lab1:;
        dead=dead->dr_inline;
    }
}


