
#include "bearCopyRight.h"
#include "grInt.h"

void  Gr_ClearMarksOfSuperNodes(sNet)

grSubNet *sNet;

{

/*
	All super nodes of sNet have their marks cleared           
*/


	grSuperNode  *sNode;

	sNode=sNet->NodeList;
	while(sNode!=NULL)
	{
		sNode->mark=0;
		sNode=sNode->nextOnList;
	}
}


void Gr_ChangeNodeNamesOfSubNet(sNet,tbc,new)

grSubNet *sNet;
BearId tbc,new;

{

	grSuperNode *pending;

	pending=sNet->NodeList;

	while(pending!=NULL)
	{
		if (pending->nodeName==tbc)
		{
			pending->nodeName=new;
		}
        pending=pending->nextOnList;
	}
}



void Gr_MergeVNetsAssignedToSameHoles(sNet,dir)

grSubNet *sNet;
int	  dir;

{

/*
If a sNet has more than one vNet then this subroutine checks if there are
vNets assigned to the same hole.If there are such vNets,it merges them 
and the second net found is deleted from the children list of sNet.  
Merging is done in terms of naming properly the supernodes.              
*/


	grVirtNet *pending,*any,*previous,*current,*wx,*bwx;
	BearId newname,tobechanged;
	int hname,flag;


	pending=sNet->children;

	while(pending!=NULL)
	{
		hname=pending->hole;
		previous=pending;

		current=pending->nextInNet;

		while(current!=NULL)
		{
			if ((current->hole!=hname)&&(Gr_AreVNetsIntermingled(
			pending,current,dir)== 0))
			{
				previous=current;
				current=current->nextInNet;
			}
			else
			{
			/*two virtual nets assigned to the same hole found*/

				Gr_ClearMarksOfSuperNodes(sNet);
if ((current->leftNode->nodeName==pending->leftNode->nodeName)||
(current->rightNode->nodeName==pending->rightNode->nodeName))
{
	/* simplified case */
	if (current->leftNode->nodeName==pending->leftNode->nodeName)
	{
		tobechanged=current->rightNode->nodeName;
		newname=pending->rightNode->nodeName;
	}
	else
	{
		tobechanged=current->leftNode->nodeName;
		newname=pending->leftNode->nodeName;
	}

	Gr_ChangeNodeNamesOfSubNet(sNet,tobechanged,newname);
	previous->nextInNet=current->nextInNet;
	current=previous->nextInNet;
}
else
{

			/* mark nodes of current */
			current->leftNode->mark=1;
			current->rightNode->mark= (-1);

			/*trace left marks*/
lab1: 
			flag=0;
			any=sNet->children;
			while(any!=NULL)
			{
				if ((any->leftNode->mark>0)&&
				(any->rightNode->mark==0))
				{
						flag=1;

					any->rightNode->mark=1;
					if (any==pending)
					{
						any->rightNode->mark= (-1);
						goto lab0; /*success*/
					}
				}
				else
				{
					if ((any->leftNode->mark==0)&&
					(any->rightNode->mark>0))
					{
						flag=1;
						any->leftNode->mark=1;
						if (any==pending)
						{
						any->leftNode->mark= (-1);
						goto lab0;  /*success*/
						}
					}
				}
				any=any->nextInNet;
			}   /*end while*/
			if (flag==1) goto lab1;

			/* no success on the left*/
			/* right search*/

			Gr_ClearMarksOfSuperNodes(sNet);
			current->leftNode->mark = (-1);
			current->rightNode->mark= 1;

			/* trace right marks*/

lab2:;
			flag=0;
			any=sNet->children;
			while(any!=NULL)
			{
				if ((any->leftNode->mark >0)&&
				(any->rightNode->mark==0))
				{
					any->rightNode->mark=1;
					if (any==pending)
					{
						any->rightNode->mark= (-1);
						goto lab0; /*success*/
					}
					flag=1;
				}
				else
				{
					if ((any->rightNode->mark>0)&&
					(any->leftNode->mark==0))
					{
						any->leftNode->mark=1;
						if (any==pending)
						{
						any->leftNode->mark= (-1);
							goto lab0;
						}
						flag=1;
					}
				}
				any=any->nextInNet;
			} /* end while*/

			if (flag==1)  
			{
				goto lab2;
			}


lab0:;  /*success*/
			/*last mark*/

			any=sNet->children;
			while(any!=NULL)
			{
				if (any->leftNode->mark < 0)
				{
					any->rightNode->mark=1;
				}
				if (any->rightNode->mark <0)
				{
					any->leftNode->mark=1;
				}
				any=any->nextInNet;
			}  /* end while*/

			/*Merging untill everything with marked nodes
			 is merged*/

lab3:;
			flag=0;
			wx=sNet->children;
			bwx=NULL;

			while(wx!=NULL)
			{
				if (((wx->leftNode->nodeName)==
				(current->leftNode->nodeName))
				&&(wx->rightNode->mark != 0)&&(wx!=current))
				{
					/*merge current to wx*/

						tobechanged =
						current->rightNode->nodeName;
						newname=wx->rightNode->nodeName;
						Gr_ChangeNodeNamesOfSubNet(
						sNet,tobechanged,newname);

						if (previous==NULL)
						{
							sNet->children=
							current->nextInNet;
						}
						else
						{
							previous->nextInNet=
							current->nextInNet;
						}
						flag=1;
						if (bwx!=current)
						{
							previous=bwx;
						}
						current=wx;
						GR_DONT_FREE((char*) current);
					}
					if (((wx->rightNode->nodeName)==
					(current->rightNode->nodeName))&&
					(wx->leftNode->mark!=0)&&(wx!=current))
					{
						/*merge current to wx*/

						tobechanged=
						current->leftNode->nodeName;
						newname=wx->leftNode->nodeName;
						Gr_ChangeNodeNamesOfSubNet(
						sNet,tobechanged,newname);

						if (previous==NULL)
						{
							sNet->children=current->							nextInNet;
						}
						else
						{
							previous->nextInNet=
							current->nextInNet;
						}
						flag=1;
						if (bwx!=current)
						{
							previous=bwx;
						}
						current=wx;
						GR_DONT_FREE((char*) current);
					}
					bwx=wx;
					wx=wx->nextInNet;
				} /* end while over wx*/

				if (flag==1)
				{
					goto lab3;
				}
 				else
				{
					goto lab5;
				}
                            } /*end else over simplification*/
			} /* end else*/
		} /*end while over current*/

		lab5:;
		pending=pending->nextInNet;
	} /*end while over pending*/

}



void Gr_MergeSuperNodesToBeConnected(sNet,parent,son,beforeSon)

grSubNet *sNet;
grSuperNode *parent,*son,*beforeSon;

/*
	Son to be merged to parent. Son and its pinRect are to be  
	freed.                                                     
	Both supernodes are from th decomposed list                
*/

{

	grPinRectangle *parentRect,*sonRect,*left,*pending;
	grSortedPin *current,*next;

	parentRect=parent->contentsPtr;
	sonRect=son->contentsPtr;

	current=sonRect->firstxPin;

	while(current!=NULL)
	{
		next=current->nextxPin;
		Gr_InsertXToPinRectangle(current,parentRect);
		current=next;
	}

	current=sonRect->firstyPin;

	while(current!=NULL)
	{
		next=current->nextyPin;
		Gr_InsertYToPinRectangle(current,parentRect);
		current=next;
	}

	Gr_UpdateBoundingBox(parentRect);

	/* remove son */

	if (beforeSon!=NULL)
	{
		beforeSon->nextOnList=son->nextOnList;
	}
	else
	{
		sNet->NodeList=sNet->NodeList->nextOnList;
	}
	GR_DONT_FREE( (char*) son);

	left=NULL;
	pending=sNet->decomposed;

	while(pending!=NULL)
	{
		if (pending==sonRect)
		{
			if (left==NULL)
			{
				sNet->decomposed=pending->nextInNet;
			}
			else
			{
				left->nextInNet=pending->nextInNet;
			}

			GR_DONT_FREE( (char*) sonRect);
			goto lab1;
		}
		else
		{
			left=pending;
			pending=pending->nextInNet;
		}
	}
lab1:;
}



void Gr_CombineSuperNodesOfSubNet(sNet)

grSubNet *sNet;

/*
	Looks for SuperNodes to be connected which have the same nodeName    
	and merges them.                                                     
	Parent node for merging must be a node of a virtNet, son must not be 
	pointed to by any virtNet.                                           
*/


{

	grSuperNode *parent,*son,*beforeSon;
	BearId pname;
	grVirtNet *vNet;

	Gr_ClearMarksOfSuperNodes(sNet);
	/* mark nodes which can serve as parents for merging*/
	vNet=sNet->children;

	while(vNet!=NULL)
	{
		vNet->leftNode->mark=1;
		vNet->rightNode->mark=1;
		vNet=vNet->nextInNet;
	}

	parent=sNet->NodeList;

	while(parent!=NULL)
	{
		if ((parent->kind==0)||(parent->mark==0))
			/* is prerouted or is not in any vNet, no action */
		{
			parent=parent->nextOnList;
		}
		else
		{
			pname=parent->nodeName;
			beforeSon=NULL;
			son=sNet->NodeList;
			if (son==parent)
			{
				beforeSon=son;
				son=son->nextOnList;
			}

			while(son!=NULL)
			{
				if (son!=parent)
				{
					if ((son->nodeName == pname)&&
					(son->side == parent->side))
					{
						if (son->mark==1)
						{
						/*change ptr in virtNet*/
							vNet=sNet->children;
							while(vNet!=NULL)
							{
								if (vNet->
								leftNode==son)
								{
								vNet->leftNode
								=parent;
								goto lab1;
								}
							if (vNet->rightNode
									==son)
								{
								vNet->rightNode=
								parent;
								goto lab1;
								}
								vNet=vNet->
								nextInNet;
							}
						}
lab1:;
						Gr_MergeSuperNodesToBeConnected(
						sNet,parent,son,beforeSon);

						if (beforeSon!=NULL)
						{
							son=beforeSon->
							nextOnList;
						}
						else
						{
							son=sNet->NodeList;
						}
					}
					else
					{
						beforeSon=son;
						son=son->nextOnList;
					}
				}
				else
				{
					beforeSon=son;
					son=son->nextOnList;
				}
			} /* end while */

			parent=parent->nextOnList;
		}
	} /* end while*/

}



void Gr_PushDownwardMultipleHoleAssignedNet(kPtr,sNet)

grRegion *kPtr;
grSubNet *sNet;

/*
	The sNet has been assigned. The cut line has more than one hole.    
	The bottlenecks have been filled. The function pushes the remaining 
	portions of a net into the children subregions of kPtr.             
                                                                     
              NO PREROUTED NET VERSION                               
*/


{

	grRegion *left,*right;
	grSubNet *newNet;
	grSuperNode *current;
	grPinRectangle *new;
	float total;
	int vtp,htp;

	left=kPtr->leftPtr;
	right=kPtr->rightPtr;


	current=sNet->NodeList;

	while(current!=NULL)
	{
		new=current->contentsPtr;
		if (new->count!=NULL)
		{
			if (current->side==1) /* sits on left*/
			{
				Gr_CreateNewSubnet(left);
				newNet=left->subNetsPtr;
			}
			else  /* sits on right */
			{
				Gr_CreateNewSubnet(right);
				newNet=right->subNetsPtr;
			}

			newNet->netname=sNet->netname;
			newNet->subname=current->nodeName;
			newNet->decCandidate = sNet->decCandidate;
			newNet->xapprox=sNet->xapprox;
			newNet->yapprox=sNet->yapprox;
			newNet->active=0;
			newNet->noLoosePins=new->count;
			newNet->noComponents=0;
			newNet->toBeConnected=new;
			newNet->critical = sNet->critical;

			if (gr_Timing == 1) /* all nets lengths calculated*/
			{
				htp=Gr_CalculateHorizontalPortionOfTree(new);
				vtp=Gr_CalculateVerticalPortionOfTree(new);
				total=htp+vtp*gr_HorVertWire;
				newNet->approxLength=total;
				((gr_HeadGrNets+sNet->netname)->currentLength)+=
				total;
				((gr_HeadGrNets+sNet->netname)->xapprox)+=
                                htp;
				((gr_HeadGrNets+sNet->netname)->yapprox)+=
                                vtp;
				newNet->xapprox=htp;
				newNet->yapprox=vtp;
			}

			if (current->side==1)  /*left */
			{
				if (left->firstPinRectanglePtr==NULL)
				{
					left->firstPinRectanglePtr=new;
					left->lastPinRectanglePtr=new;
					new->nextOnList=NULL;
				}
				else
				{
					new->nextOnList=
					left->firstPinRectanglePtr;
					left->firstPinRectanglePtr=new;
				}
			}  /* end is on left */
			else
			{   /* is on right */
				if (right->firstPinRectanglePtr == NULL)
				{
					right->firstPinRectanglePtr=new;
					right->lastPinRectanglePtr=new;
					new->nextOnList=NULL;
				}
				else
				{
					new->nextOnList=
					right->firstPinRectanglePtr;
					right->firstPinRectanglePtr=new;
				}
			}   /* end is on right */
			Gr_SetBoundBox(newNet);
		}

		current=current->nextOnList;
	}  /* end while */

}


/*
*---------------------------------------------------------------------------
*	Gr_AreVNetsIntermingled(pending,current,dir)
*	Results		: 1 if one net has a resident pin in a bottleneck
*			  assigned to the other one
*			  0 otherwise.
*	Side effects	: none.
*---------------------------------------------------------------------------
*/


int	Gr_AreVNetsIntermingled(pending,current,dir)

grVirtNet	*pending, *current;
int		 dir;

{
	int		hole;
	grBlock		*block;
	grSortedPin	*gSPin;
	int		par, flag;
	grVirtNet	*vNet;

	par = 0;

lab1 : ;
	if (par == 0)
	{
		hole = pending->hole;
		vNet = current;
	}
	else
	{
		hole = current->hole;
		vNet = pending;
	}

	if ((grHeadHolePtr + hole)->status == 0)
	{
		block = (grHeadHolePtr + hole)->leftBlockPtr;
		if (block == NULL)
		{
			block = (grHeadHolePtr + hole)->rightBlockPtr;
		}

		flag =0;
lab2 : ;
		if (flag == 0)
		{
			gSPin = vNet->leftNode->contentsPtr->firstxPin;
		}
		else
		{
			gSPin = vNet->rightNode->contentsPtr->firstxPin;
		}

		while(gSPin != NULL)
		{
		 	if (dir == 1)
			{
				if (Gr_IsSortedPinInsideBlock(block,gSPin,0)>0)
				{
					return (1);
				}
			}
			else

			{
				if (Gr_IsSortedPinInsideBlock(block,gSPin,1)>0)
				{
					return (1);
				}
			}
			gSPin = gSPin->nextxPin;
		}

		if (flag == 0)
		{
			flag = 1;
			goto lab2;
		}
	}

	if (par == 0)
	{
		par = 1;
		goto lab1;
	}
	return (0);
}
