
/* mmsSetMem.c --
 *
 *     (Advising Professor - E. S. Kuh)
 *
 */

#ifndef lint
static char rcsid[] = "$Header$";
#endif  not lint

#include "bearCopyRight.h"
#include "grInt.h"


Gr_Set1Memor()
{
    MALLOC(grKeyBlock * ,grKeyToBlocksHeadPtr,
        (grBottleneckTileCount+1) *sizeof (grKeyBlock));
    MALLOC(grPrimit *, gr_Bitmap, ((grBottleneckTileCount+2)*
        (grBottleneckTileCount+2))*sizeof (grPrimit));
    MALLOC(grPrimit *, gr_xcoord, (grBottleneckTileCount+2)*sizeof (grPrimit));
    MALLOC(grPrimit *, gr_ycoord, (grBottleneckTileCount+2)*sizeof (grPrimit));
}


void
Gr_Setup1LAss()
/*
 * Get memory for Linear Sum Assignment Problem.
 */
{
    int i, su, numOfBytes;

    su = (m+1)*(n+1);
    MALLOC(grPrimit *, c, ((m+1)*(n+1)+1) * sizeof (grPrimit));
    for (i=1;i<=su;i++)
    {
        (c+i)->number = 0;

    }
    numOfBytes = (n + 1) * sizeof (grPrimit);
    MALLOC(grPrimit *, grACap, numOfBytes);
    for (i=1;i<=n;i++)
    {
        (grACap+i)->number = 0;
    }
}


void
Gr_Setup2LAss()
/*
 * Get memory for Linear Sum Assignment Problem.
 */
{
    int i, j, licz, pom, numOfBytes;

    MALLOC(grIndex *, vNetHead, (m + 1) * sizeof (grIndex));

    numOfBytes = (neff + 1) * sizeof (grPrimit);
    MALLOC(grPrimit *, cap, numOfBytes);
    MALLOC(grPrimit *, row, numOfBytes);
    MALLOC(grPrimit *, h2, numOfBytes);
    MALLOC(grPrimit *, h4, numOfBytes);
    MALLOC(grPrimit *, h5, numOfBytes);
    MALLOC(grPrimit *, h6, numOfBytes);
    MALLOC(grPrimit *, map, numOfBytes);

    for (i=1;i<=neff;i++)
    {
        (cap+i)->number=1; /* all capacities are 1 */
        (row+i)->number=0;
        (h2+i)->number=0;
        (h4+i)->number=0;
        (h5+i)->number=0;
        (h6+i)->number=0;
    }

    numOfBytes = (m + 1) * sizeof (grPrimit);
    MALLOC(grPrimit *, col, numOfBytes);
    MALLOC(grPrimit *, nexts, numOfBytes);
    MALLOC(grPrimit *, h1, numOfBytes);
    MALLOC(grPrimit *, h3, numOfBytes);

    for (i=1;i<=m;i++)
    {
        (col+i)->number=0;
        (nexts+i)->number=0;
        (h1+i)->number=0;
        (h3+i)->number=0;
    }

    MALLOC(grPrimit *, mback, (n + 1) * sizeof (grPrimit));
#ifdef DEBUG
    if (n == 0) {
        Bear_PrintFatalErr("Gr_Setup2LAss() failed : n == 0");
    }
#endif DEBUG
    (mback+1)->number = 1;
    if (n>1)
    {
        for (i=2;i<=n;i++)
        {
            (mback+i)->number = (mback+i-1)->number + (grACap+i)->number;
        }
    }

    licz=0;
    for (j=1;j<=n;j++)
    {
        pom=(grACap+j)->number;
        for (i=1;i<=pom;i++)
        {
            licz++;
#ifdef DEBUG
            if (licz > neff) {
           Bear_PrintFatalErr("Gr_Setup2LAss() failed : map index out of range");
            }
#endif DEBUG
            (map+licz)->number=j;
        }
    }
}


void Gr_CreateApartments()
/*
 * Memory assignment for rooms.
 */
{
    int     i, j, pom;
    grRoom  *roomPtr;

    MALLOC(grRoom *, gr_RoomPlan,
        (gr_totxgrid+2)*(gr_totygrid+2) * sizeof (grRoom));

    for (i=1;i<=gr_totygrid;i++)
    {
        pom=gr_totxgrid*(i-1);

        for (j=1;j<=gr_totxgrid;j++)
        {
            roomPtr=(gr_RoomPlan+pom+j);
            roomPtr->who=0;
            roomPtr->c_x=0;
            roomPtr->c_y=0;
            roomPtr->dist=0;
            roomPtr->status=0;
            roomPtr->father=NULL;
        }
    }
}

void Gr_CreatePseudoBlock(num,type,x,y)

int num,type,x,y;

/*
Create a new block , name it num, persona = 6 and put
it at the end of the list.
Blocks created here are used to convert bottleneck lines
into "regular" bottlenecks which are very thin. Pseudo
blocks are very small and sit at terminating points
of bottleneck lines. Dimensions of pseudo blocks along
bottleneck lines are 1. Thus the shortest bottleneck
line must be 3. Otherwise there might be problems with
round-off errors and pseudo-pins coinciding with the 
corners of blocks.

xpos,ypos coordinates depend on type of bottleNeck line,
x,y are coordinates of bnline.
*/

{
    MALLOC(grBlock*,grLastBlockPtr->nextBlockPtr,sizeof (grBlock));
    grLastBlockPtr=grLastBlockPtr->nextBlockPtr;
    grLastBlockPtr->nextBlockPtr=NULL;
    grLastBlockPtr->name=num;
    grLastBlockPtr->tilePtr=NULL;
    grLastBlockPtr->persona=6;
    grLastBlockPtr->avCap=0;

    grLastBlockPtr->dCell=0;
    grLastBlockPtr->top=NULL;
    grLastBlockPtr->bot=NULL;
    grLastBlockPtr->right=NULL;
    grLastBlockPtr->left=NULL;
    grLastBlockPtr->tooThin=0;

    if ((type==1)||(type==2)||(type==5)||(type==7))
    {
        grLastBlockPtr->xpos=x-1;
        grLastBlockPtr->ypos=y;
        grLastBlockPtr->height=1;
        grLastBlockPtr->width=2;
    }

    if ((type==3)||(type==6))
    {
        grLastBlockPtr->xpos=x-1;
        grLastBlockPtr->ypos=y-1;
        grLastBlockPtr->height=2;
        grLastBlockPtr->width=1;
    }

    if ((type==4)||(type==8))
    {
        grLastBlockPtr->xpos=x;
        grLastBlockPtr->ypos=y-1;
        grLastBlockPtr->height=2;
        grLastBlockPtr->width=1;
    }

}


void
Gr_CreatePsHBn(num,type,gline)
int         num,type;
grBnLine    *gline;
{
    MALLOC(grBlock*,grLastBlockPtr->nextBlockPtr,sizeof (grBlock));

    grLastBlockPtr=grLastBlockPtr->nextBlockPtr;
    grLastBlockPtr->nextBlockPtr=NULL;
    grLastBlockPtr->name=num;
    grLastBlockPtr->bnLinePtr=gline->bnLinePtr;
    grLastBlockPtr->persona=5; /*CHANGE TO 5 */
    grLastBlockPtr->tilePtr=gline->tilePtr;
    grLastBlockPtr->width=gline->rt - gline->lb - 1;
    grLastBlockPtr->height=1;
    grLastBlockPtr->avCap =
        (Tp_GetCapacityOfBnLine(gline->bnLinePtr) -
            Tp_GetDensityOfBnLine(gline->bnLinePtr)) / gr_vertDesRule;
#ifdef DEBUG
{
    if (grLastBlockPtr->avCap < 0) {
        Bear_PrintFatalErr("Gr_CreatePsHBn() failed : negative number");
    }
}
#endif DEBUG

    grLastBlockPtr->dCell=0;
    grLastBlockPtr->top=NULL;
    grLastBlockPtr->bot=NULL;
    grLastBlockPtr->right=NULL;
    grLastBlockPtr->left=NULL;
    grLastBlockPtr->tooThin=0;

    if (type==1)
    {
        grLastBlockPtr->xpos=gline->lb +1;
        grLastBlockPtr->ypos=gline->base;
    }

    if (type==2)
    {
        grLastBlockPtr->xpos=gline->lb;
        grLastBlockPtr->ypos=gline->base;
    }

    if (type==3)
    {
        grLastBlockPtr->xpos=gline->lb;
        grLastBlockPtr->ypos=gline->base - 1;
    }

    if (type==4)
    {
        grLastBlockPtr->xpos=gline->lb+1;
        grLastBlockPtr->ypos=gline->base - 1;
    }

}


void
Gr_CreatePsVBn(num,type,gline)
int         num,type;
grBnLine    *gline;
{
    MALLOC(grBlock*,grLastBlockPtr->nextBlockPtr,sizeof (grBlock));

    grLastBlockPtr=grLastBlockPtr->nextBlockPtr;
    grLastBlockPtr->nextBlockPtr=NULL;
    grLastBlockPtr->name=num;
    grLastBlockPtr->bnLinePtr=gline->bnLinePtr;
    grLastBlockPtr->persona=4; 
    grLastBlockPtr->tilePtr=gline->tilePtr;
    grLastBlockPtr->height=gline->rt - gline->lb - 1;
    grLastBlockPtr->width=1;
    grLastBlockPtr->avCap =
        (Tp_GetCapacityOfBnLine(gline->bnLinePtr) -
            Tp_GetDensityOfBnLine(gline->bnLinePtr)) / gr_horzDesRule;
#ifdef DEBUG
{
    if (grLastBlockPtr->avCap < 0) {
        Bear_PrintFatalErr("Gr_CreatePsVBn() failed : negative number");
    }
}
#endif DEBUG

    grLastBlockPtr->dCell=0;
    grLastBlockPtr->top=NULL;
    grLastBlockPtr->bot=NULL;
    grLastBlockPtr->right=NULL;
    grLastBlockPtr->left=NULL;
    grLastBlockPtr->tooThin=0;

    if (type==5)
    {
        grLastBlockPtr->xpos=gline->base;
        grLastBlockPtr->ypos=gline->lb + 1;
    }

    if (type==6)
    {
        grLastBlockPtr->xpos=gline->base - 1;
        grLastBlockPtr->ypos=gline->lb;
    }

    if (type==7)
    {
        grLastBlockPtr->xpos=gline->base - 1;
        grLastBlockPtr->ypos=gline->lb  +1 ;
    }

    if (type==8)
    {
        grLastBlockPtr->xpos=gline->base;
        grLastBlockPtr->ypos=gline->lb;
    }

}

