
/* mmsSort.c --
 *
 *     Malgorzata Marek-Sadowska
 *     (Advising Professor - E. S. Kuh)
 *
 * Copyright (C) 1988 Regents of the University of California
 * All rights reserved.
 */

#ifndef lint
static char rcsid[] = "$Header$";
#endif  not lint

#include "grInt.h"


BearId Gr_GetNewSubNetName()

{
	return ( Mac_GenerateId() );
}


int Gr_GetNewSegmentName()

{
	return ( Mac_GenerateId() );
}

void Gr_InsertXGeneral(netPtr,sortedPinPtr)

grNet *netPtr;
grSortedPin *sortedPinPtr;

/*
	put grSortedPin on its proper position with respect to x coordinate
	this is a position regardless pinRect membership                   
*/

{

	grSortedPin *current,*best;
	int xin,yin;

	if (netPtr->firstXPin==NULL)
	{
		netPtr->firstXPin=sortedPinPtr;
		sortedPinPtr->nextXPin=NULL;
	}
	else
	{
		current=netPtr->firstXPin;
		best=NULL;
		xin=(sortedPinPtr->pinPtr->x);
		yin=(sortedPinPtr->pinPtr->y);

		while(current!=NULL)
		{
			if ((current->pinPtr->x) < xin)
			{
				best=current;
				goto lab; /*continue search*/
			}
			if ((current->pinPtr->x)==xin)
			{
				if ((current->pinPtr->y) < yin)
				{
					best=current;
					goto lab; /*continue search*/
				}
			}
			/* insert */
			if (best==NULL)
			{
				sortedPinPtr->nextXPin=netPtr->firstXPin;
				netPtr->firstXPin=sortedPinPtr;
				goto labexit; /*exit from the while loop*/
			}
			else
			{
				best->nextXPin=sortedPinPtr;
				sortedPinPtr->nextXPin=current;
				goto labexit; /*exit from the while loop*/
			}
lab: 
			current=current->nextXPin;
		} /*end while loop*/

		if (current==NULL) /* insert at the end*/
		{
			sortedPinPtr->nextXPin=NULL;
			best->nextXPin=sortedPinPtr;
		}
labexit:;
	}
}

void Gr_InsertYGeneral(netPtr,sortedPinPtr)

grNet *netPtr;
grSortedPin *sortedPinPtr;

/*
	put grSortedPin on its proper y position regardless pinRect membership
*/

{

	grSortedPin *current,*best;
	int xin,yin;

	if (netPtr->firstYPin==NULL)
	{
		netPtr->firstYPin=sortedPinPtr;
		sortedPinPtr->nextYPin=NULL;
	}
	else
	{
		current=netPtr->firstYPin;
		best=NULL;
		xin=sortedPinPtr->pinPtr->x;
		yin=sortedPinPtr->pinPtr->y;

		while(current!=NULL)
		{
			if ((current->pinPtr->y) < yin)
			{
				best=current;
				goto lab;  /* continue search */
			}
			if ((current->pinPtr->y) == yin)
			{
				if ((current->pinPtr->x) < xin)
				{
					best=current;
					goto lab;  /* continue search */
				}
			}

			/* insert */
			if (best==NULL)
			{
				sortedPinPtr->nextYPin = netPtr->firstYPin;
				netPtr->firstYPin = sortedPinPtr;
				goto labexit;  /* exit from the while loop */
			}
			else
			{
				best->nextYPin = sortedPinPtr;
				sortedPinPtr->nextYPin = current;
				goto labexit; /* exit from the while loop */
			}
lab: 
			current=current->nextYPin;  /* continue search */
		}  /* end while loop */

		if (current==NULL)  /* insert at the end */
		{
			sortedPinPtr->nextYPin=NULL;
			best->nextYPin = sortedPinPtr;
		}
labexit:;
	}
}

void Gr_InsertXToPinRectangle(sortedPinPtr,pinRectanglePtr)

/*
	insert sorted pin into a proper x position in pin rectangle 
*/

grSortedPin *sortedPinPtr;
grPinRectangle *pinRectanglePtr;

{

	int xin,yin;
	grSortedPin *current,*best;

	xin=sortedPinPtr->pinPtr->x;
	yin=sortedPinPtr->pinPtr->y;

	if ((pinRectanglePtr->minx)== 0)  /* box update */
	{
		(pinRectanglePtr->minx) = xin;
        }
        if ((pinRectanglePtr->maxx)==0)
        {
		(pinRectanglePtr->maxx) = xin;
	}
	else
	{
		if (( pinRectanglePtr->minx) > xin )
			(pinRectanglePtr->minx) = xin;

		if (( pinRectanglePtr->maxx) < xin)
			pinRectanglePtr->maxx = xin;
	}   /* end box update */

	if ((pinRectanglePtr->firstxPin) == NULL)
	{
		pinRectanglePtr->firstxPin = sortedPinPtr;
		sortedPinPtr->nextxPin = NULL;
	}
	else
	{
		current = pinRectanglePtr->firstxPin;
		best = NULL;

		while(current!=NULL)
		{
			if ((current->pinPtr->x) < xin)
			{
				best=current;
				goto lab; /* continue search */
			}
			if ((current->pinPtr->x) == xin)
			{
				if ((current->pinPtr->y) < yin)
				{
					best = current;
					goto lab;  /* continue search*/
				}
			}

			/* insert */
			if (best == NULL)
			{
				sortedPinPtr->nextxPin =
				pinRectanglePtr->firstxPin;
				pinRectanglePtr->firstxPin = sortedPinPtr;
				goto labexit;  /* exit from the while loop */
			}
			else
			{
				best->nextxPin = sortedPinPtr;
				sortedPinPtr->nextxPin = current;
				goto labexit;  /* exit from the while loop */
			}
lab: 
			current=current->nextxPin;
		}  /* end of while*/

		if (current == NULL)  /*insert at the end */
		{
			sortedPinPtr->nextxPin = NULL;
			best->nextxPin = sortedPinPtr;
		}
labexit:;
	}
}

void Gr_InsertYToPinRectangle(sortedPinPtr,pinRectanglePtr)

/*
	insert sorted pin into a proper y position in a pin rectangle 
*/

grSortedPin *sortedPinPtr;
grPinRectangle *pinRectanglePtr;

{

	int xin,yin;
	grSortedPin *current,*best;

	xin = sortedPinPtr->pinPtr->x;
	yin = sortedPinPtr->pinPtr->y;

	/*box update */
	if (pinRectanglePtr->miny == 0 )
	{
		pinRectanglePtr->miny = yin;
        }
        if (pinRectanglePtr->maxy == 0)
        {
		pinRectanglePtr->maxy = yin;
	}
	else
	{
		if ((pinRectanglePtr->miny) > yin)
			pinRectanglePtr->miny = yin;

		if ((pinRectanglePtr->maxy) < yin)
			pinRectanglePtr->maxy = yin;
	}    /* end box update */

	if (pinRectanglePtr->firstyPin ==NULL)
	{
		pinRectanglePtr->firstyPin = sortedPinPtr;
		sortedPinPtr->nextyPin = NULL;
	}
	else
	{
		current=pinRectanglePtr->firstyPin;
		best = NULL;

		while(current!=NULL)
		{
			if (( current->pinPtr->y) < yin)
			{
				best=current;
				goto lab;  /* continue search */
			}
			if ((current->pinPtr->y) == yin)
			{
				if ((current->pinPtr->x) < xin)
				{
					best=current;
					goto lab;  /* continue search */
				}
			}

			/* insert */
			if (best == NULL)
			{
				sortedPinPtr->nextyPin =
				pinRectanglePtr->firstyPin;
				pinRectanglePtr->firstyPin = sortedPinPtr;
				goto labexit;  /* exit from while loop */
			}
			else
			{
				best->nextyPin = sortedPinPtr;
				sortedPinPtr->nextyPin = current;
				goto labexit; /* exit from while loop */
			}
lab:  
			current=current->nextyPin;
		}  /* end of while */
		if (current == NULL)  /*insert at the end */
		{
			sortedPinPtr->nextyPin = NULL;
			best->nextyPin = sortedPinPtr;
		}
labexit:;
	}
}



BearStatus
GrMkeSortedPins(pinCount, flag)

int pinCount;
int flag;

/*
	This function creates sorted pins and all structures related to them.
	If flag=0 it means that the current net is not prerouted, isoladed 
	pins are omitted and a warning is printed.                         
	If flag=1 the current net is prerouted and the isolated pins are  
	groupped together.                                                  
*/

{
	grPin *runPtr;
	int i,mix,miy,mx,my,treeControl;
	grSortedPin *currentSortedPinPtr,*nextSortedPinPtr,*bestSortedPinPtr;
	grSortedPin *runSortedPinPtr;

	if ((flag==0)&&(pinCount==1))
	{
		printf("\n WARNING : single pin nets in the input data ");
		return (BEAR_STOP_SEARCH);
	}

	/* memory assignment*/
        currentSortedPinPtr=Gr_CreateSortedPin();

	currentSortedPinPtr->pinPtr = gr_HeadLastToSort;
	nextSortedPinPtr = currentSortedPinPtr;
	runPtr = gr_HeadLastToSort;

	for (i=1;i<pinCount;i++)
	{
                nextSortedPinPtr=Gr_CreateSortedPin();
		runPtr = runPtr->nextPtr;
		nextSortedPinPtr->pinPtr = runPtr;
	}


	if (pinCount>1)
	{
		/* unconnected net or a subtree*/

		if ((gr_HeadGrNets+gr_NetCount)->areConnected==NULL)
		{
			treeControl=0;
		}
		else
		{
			treeControl=1;
		}

		Gr_CreateNewPinRectangle(treeControl);



                 for (i=0;i<pinCount;i++)
                 {
                    nextSortedPinPtr->side=0;
                    Gr_InsertXToPinRectangle(nextSortedPinPtr,
			gr_LastPinRectanglePtr);
                    Gr_InsertYToPinRectangle(nextSortedPinPtr,
			gr_LastPinRectanglePtr);
                    nextSortedPinPtr=nextSortedPinPtr->nextOnList;
                 }

                 Gr_UpdateBoundingBox(gr_LastPinRectanglePtr);


		if (flag==0)
		{
			(gr_HeadGrNets+gr_NetCount)->loosePins=
			gr_LastPinRectanglePtr;
		}

		if ((flag==1)&&(treeControl==0))
		{
			/* first portion of prerouted net met*/
			(gr_HeadGrNets+gr_NetCount)->areConnected =
			 gr_LastPinRectanglePtr;
		}

		if (flag==1) /* get a non zero name for prerouted segment*/
		{
			gr_LastPinRectanglePtr->name = Gr_GetNewSegmentName();
		}


	}
	/* end of sort for groups of pins*/

	/*now sorting of isolated pins treated as trees*/

	if ((flag==1)&&(pinCount==1))
	{
		/* update #components and #loosepins*/

		((gr_HeadGrNets+gr_NetCount)->noComponents)--;
		((gr_HeadGrNets+gr_NetCount)->noLoosePins)++;

		/*put common information to the sorted pin*/

		currentSortedPinPtr->side=0;

		treeControl=0;

		if (((gr_HeadGrNets+gr_NetCount)->loosePins)==NULL)
		{
			/*first loose pin met*/
			Gr_CreateNewPinRectangle(treeControl);
			gr_LastPinRectanglePtr->firstxPin=currentSortedPinPtr;
			gr_LastPinRectanglePtr->firstyPin=currentSortedPinPtr;
			gr_LastPinRectanglePtr->minx=gr_HeadLastToSort->x;
			gr_LastPinRectanglePtr->maxx=gr_HeadLastToSort->x;
			gr_LastPinRectanglePtr->miny=gr_HeadLastToSort->y;
			gr_LastPinRectanglePtr->maxy=gr_HeadLastToSort->y;
			gr_LastPinRectanglePtr->count=1;
			(gr_HeadGrNets+gr_NetCount)->loosePins=
			gr_LastPinRectanglePtr;
			/*end of initialization of loose pin
			 stuff for the first pin*/
		}
		else
		{
			/*insert the new pin into the existing structures*/

			/*update the bounding box*/

			if (((gr_HeadLastToSort->x)<
			(gr_HeadGrNets+gr_NetCount)->loosePins->minx))
			{
				(gr_HeadGrNets+gr_NetCount)->loosePins->minx
				=gr_HeadLastToSort->x;
			}
			else
			{
				if (((gr_HeadLastToSort->x)>(gr_HeadGrNets+
				gr_NetCount)->loosePins->maxx))
				{
					(gr_HeadGrNets+gr_NetCount)->
					loosePins->maxx=gr_HeadLastToSort->x;
				}
			}
			/*end x box update*/

			if (((gr_HeadLastToSort->y) < (gr_HeadGrNets
			+gr_NetCount)->loosePins->miny))
			{
				(gr_HeadGrNets+gr_NetCount)->loosePins->miny
				=gr_HeadLastToSort->y;
			}
			else
			{
				if (((gr_HeadLastToSort->y) > (gr_HeadGrNets+
				gr_NetCount)->loosePins->maxy))
				{
					(gr_HeadGrNets+gr_NetCount)->
					loosePins->maxy=gr_HeadLastToSort->y;
				}
			}   /*end y box update */
			/* end bounding box update*/

			/* put the last pin in correct place 
				with respect to x coordinate*/

			runSortedPinPtr=(gr_HeadGrNets+gr_NetCount)->
			loosePins->firstxPin;
			mx=gr_HeadLastToSort->x;
			mix=runSortedPinPtr->pinPtr->x;
			if (mx>mix)   /* need to be inserted inside the chain*/
			{
				bestSortedPinPtr=runSortedPinPtr;
				while(runSortedPinPtr->nextxPin!=NULL)
				{
					runSortedPinPtr=runSortedPinPtr->
					nextxPin;
					mix=runSortedPinPtr->pinPtr->x;
					if (mx>mix)
						bestSortedPinPtr=
						runSortedPinPtr;
				}
				/* insert */
				currentSortedPinPtr->nextxPin=
				bestSortedPinPtr->nextxPin;
				bestSortedPinPtr->nextxPin=currentSortedPinPtr;
			}
			else
			{
				/* put in the front */
				currentSortedPinPtr->nextxPin=
				(gr_HeadGrNets+gr_NetCount)->loosePins->
				    firstxPin;
				(gr_HeadGrNets+gr_NetCount)->loosePins->
				firstxPin=currentSortedPinPtr;
			}

			/* put the last pin in correct place with respect
			 to y coordinate*/

			runSortedPinPtr=(gr_HeadGrNets+gr_NetCount)->
			loosePins->firstyPin;
			my=gr_HeadLastToSort->y;
			miy=runSortedPinPtr->pinPtr->y;
			if (my>miy)  /* need to be inserted inside the chain */
			{
				bestSortedPinPtr=runSortedPinPtr;
				while(runSortedPinPtr->nextyPin!=NULL)
				{
					runSortedPinPtr=runSortedPinPtr->
					nextyPin;
					miy=runSortedPinPtr->pinPtr->y;
					if (my>miy)
					{
						bestSortedPinPtr=
						runSortedPinPtr;
					}
				}

				/*insert*/

				currentSortedPinPtr->nextyPin=
				bestSortedPinPtr->nextyPin;
				bestSortedPinPtr->nextyPin=
				currentSortedPinPtr;
			}
			else
			{
				/* put in the front */
				currentSortedPinPtr->nextyPin=
				(gr_HeadGrNets+gr_NetCount)->loosePins->
				    firstyPin;
				(gr_HeadGrNets+gr_NetCount)->loosePins->
				firstyPin=currentSortedPinPtr;
			}
			/* end pin insertion*/
		}
	}
	gr_HeadLastToSort = NULL;
	return (BEAR_CONTINUE_SEARCH);
}



void Gr_EstablishHardLinksForSortedPins()

/*
	Fills in nextXPin and nextYPin for sorted pins. these links are not     
	removed during the global routing process   
*/

{

	grSortedPin *run;
	grPinRectangle *current;
	grNet *gNet;
	int i;

	for (i=1;i<=gr_NetCount;i++)
	{
		gNet=(gr_HeadGrNets+i);
		current=gNet->loosePins;
		if (current!=NULL)
		{
			run=current->firstxPin;
			while(run!=NULL)
			{
				Gr_InsertXGeneral(gNet,run);
				Gr_InsertYGeneral(gNet,run);
				run=run->nextxPin;
			}
		}
		current=gNet->areConnected;
		while(current!=NULL)
		{
			run=current->firstxPin;
			while(run!=NULL)
			{
				Gr_InsertXGeneral(gNet,run);
				Gr_InsertYGeneral(gNet,run);
				run=run->nextxPin;
			}
		}
	}
}

