



#include "grInt.h"

void Gr_CreateNewSubnet(kPtr)

/*
	creates a new subnet for a region pointed to by kPtr
*/

grRegion *kPtr;

{
	grSubNet *subNetPtr;

	/*get memory*/
	MALLOC(grSubNet*,subNetPtr,sizeof (grSubNet));
	/*link it*/
	(subNetPtr->nextOnList) = (kPtr->subNetsPtr);
	kPtr->subNetsPtr = subNetPtr;
	subNetPtr->NodeList = NULL;
	subNetPtr->children = NULL;
	subNetPtr->decCandidate = 0; 
	/* by default net is not a decomposition candidate */
        subNetPtr->critical=0; /* by default net is not critical*/
	subNetPtr->xapprox=0;
	subNetPtr->yapprox=0;
        subNetPtr->active=0;
        subNetPtr->approxLength=0;
	subNetPtr->toBeConnected = NULL;
	subNetPtr->areConnected =NULL;
	subNetPtr->tree=NULL;
	subNetPtr->decomposed=NULL;
}


grVirtNet *Gr_CreateNewVirtNet(sNet)

grSubNet *sNet;

{

	grVirtNet *vNet;

	MALLOC(grVirtNet*,vNet,sizeof (grVirtNet));
	vNet->nextInNet=sNet->children;
	sNet->children=vNet;

	vNet->leftNode=NULL;
	vNet->rightNode=NULL;

	vNet->netName=0;
	vNet->subNetName=0;
	vNet->assiName=0;
	vNet->hole=0;

	return (vNet);

}

void Gr_PutJointBox(subNetPtr)
grSubNet *subNetPtr;

/* for a subnet pointed to by subNetPtr */
/* create the smallest enclosing rectangle*/

{

	grPinRectangle *arrowPtr;
	int mix,miy,mxx,mxy;

	mix=0;
	miy=0;
	mxx=0;
	mxy=0;
	if ((subNetPtr->toBeConnected)!=NULL)
	{
		mix=subNetPtr->toBeConnected->minx;
		miy=subNetPtr->toBeConnected->miny;
		mxx=subNetPtr->toBeConnected->maxx;
		mxy=subNetPtr->toBeConnected->maxy;
	}

	arrowPtr=subNetPtr->areConnected;
	while(arrowPtr!=NULL)
	{
		if (mix>arrowPtr->minx)
			mix=arrowPtr->minx;

		if (miy>arrowPtr->miny)
			miy=arrowPtr->miny;

		if (mxx<arrowPtr->maxx)
			mxx=arrowPtr->maxx;

		if (mxy<arrowPtr->maxy)
			mxy=arrowPtr->maxy;

		arrowPtr=arrowPtr->nextInNet;

	}

	subNetPtr->maxx=mxx;
	subNetPtr->minx=mix;
	subNetPtr->maxy=mxy;
	subNetPtr->miny=miy;

}

int Gr_HorzBoxCut(box,ypos)

grPinRectangle *box;
int ypos;

/*
	returns different integer values indicating if a horizontal line 
	has an intersection with a box                                   
	1 internal intersection 
	2 touches at the top side of a box
	3 touches at the bottom of the box 
	4 if no intersection and the line is above the box
	5 if no intersection and the line is below the box
*/

{

	if (((box->miny)<ypos)&&((box->maxy)>ypos))
		return (1);

	if ((box->miny)>ypos)
		return (5);

	if ((box->maxy)<ypos)
		return (4);

	if ((box->miny)==ypos)
		return (3);

	if ((box->maxy)==ypos)
		return (2);

	return (0);
}


int Gr_VertBoxCut(box,xpos)

grPinRectangle *box;
int xpos;

/*
	returns 1 if a vertical line intersects internally the box 
	returns 2 if a vertical line touches the box at its left side
	returns 3 if a vertical line touches the box at its right side
	returns 4 if a vertical line is an the left of the box
	returns 5 if a vertical line is an the right of the box
returns 5 if a vertical line is on the right of the box
*/
{

	if (((box->minx)<xpos)&&((box->maxx)>xpos))
		return (1);

	if ((box->minx)>xpos)
		return (4);

	if ((box->maxx)<xpos)
		return (5);

	if ((box->maxx)==xpos)
		return (3);

	if ((box->minx)==xpos)
		return (2);

	return (0);
}
