

#include "grInt.h"

void Gr_MarkCurrentBtnCut(kPtr)

grRegion *kPtr;

/*
	For a currently cut region it marks rooms which are included 
	in the current cut                                           
*/

{

	int xv,yv,xr,yt;
	int i;
	grBlock *block;

	xv=kPtr->xvirt +1;
	yv=kPtr->yvirt +1;
	xr=xv+kPtr->whvirt -1;
	yt=yv+kPtr->hvirt -1;

	for (i=1;i<=n;i++)
		if (((grHeadHolePtr+i)->status==0)||
		((grHeadHolePtr+i)->status==3))
		{
			block=(grHeadHolePtr+i)->leftBlockPtr;
			if (block==NULL)
			{
				block=(grHeadHolePtr+i)->rightBlockPtr;
			}
			Gr_MarkBlockRoomsInRegion(xv,yv,xr,yt,block,6);
		}
}


void Gr_MarkBlockRoomsInRegion(xv,yv,xr,yt,block,val)

int xv,yv,xr,yt; /*boundary of the region*/
grBlock *block;
int val;

/* all rooms of a block are marked val in redion given by the bounds*/

{
	int xvb,yvb,wvb,hvb,a,b,c,d;
	int l,u;

	xvb=block->xvirt;
	yvb=block->yvirt;
	wvb=block->wvirt;
	hvb=block->hvirt;

	a=xvb+1;
	b=xvb+wvb;
	c=yvb+1;
	d=yvb+hvb;

	if (a<xv)
	{
		a=xv;
	}

	if (b>xr)
	{
		b=xr;
	}

	if (c<yv)
	{
		c=yv;
	}

	if (d>yt)
	{
		d=yt;
	}

	if ((a>b)||(c>d))
	{
		return;
	}

	for (l=a;l<=b;l++)
	{
		for (u=c;u<=d;u++)
		{
			(gr_RoomPlan+Gr_WhoAmI(u,l))->status = val;
		}
	}
}



void Gr_CleanUpRooms(kPtr,par)

grRegion *kPtr;
int par;
/*
	par =0 only routable rooms are cleaned, par=1 routable+starts,
   	par=2 routable+starts+targets
*/

{

	int a,b,c,d,u,l,pom;

	a=kPtr->xvirt+1;
	b=a+kPtr->whvirt -1;
	c=kPtr->yvirt +1;
	d=c+kPtr->hvirt -1;

	for (l=a;l<=b;l++)
	{
		for (u=c;u<=d;u++)
		{
			pom=Gr_WhoAmI(u,l);

			if (par==0)
			{
				if ((gr_RoomPlan+pom)->status==0)
				{
					(gr_RoomPlan+pom)->dist=0;
					(gr_RoomPlan+pom)->father=NULL;
				}
			}

			if (par==1)
			{
				if ((gr_RoomPlan+pom)->status<=2)
				{
					(gr_RoomPlan+pom)->dist=0;
					(gr_RoomPlan+pom)->father=NULL;
					(gr_RoomPlan+pom)->status=0;
				}
			}

			if (par==2)
			{
				if ((gr_RoomPlan+pom)->status<=5)
				{
					(gr_RoomPlan+pom)->dist=0;
					(gr_RoomPlan+pom)->father=NULL;
					(gr_RoomPlan+pom)->status=0;
				}
			}
		}
	}
}



grRoom *Gr_GetTopRoom(gRoom,ytop)

grRoom *gRoom;
int ytop;

{
	int xv,yv;
	grRoom *new;

	yv=gRoom->yv;
	yv++;
	if (yv<=ytop)
	{
		xv=gRoom->xv;
		new=Gr_GetRoom(yv,xv);
		if ((new->status>=6)||(new==gRoom->father))
		{
			return (NULL);
		}
		else
		{
			return (new);
		}
	}
	return (NULL);
}


grRoom *Gr_GetRightRoom(gRoom,xright)

grRoom *gRoom;
int xright;

{
	int xv,yv;
	grRoom *new;

	xv=gRoom->xv;
	xv++;
	if (xv<=xright)
	{
		yv=gRoom->yv;
		new=Gr_GetRoom(yv,xv);
		if ((new->status>=6)||(new==gRoom->father))
		{
			return (NULL);
		}
		else
		{
			return (new);
		}
	}
	return (NULL);
}


grRoom *Gr_GetBotRoom(gRoom,ybot)

grRoom *gRoom;
int ybot;

{
	int xv,yv;
	grRoom *new;

	yv=gRoom->yv;
	yv--;
	if (yv>=ybot)
	{
		xv=gRoom->xv;
		new=Gr_GetRoom(yv,xv);
		if ((new->status>=6)||(new==gRoom->father))
		{
			return (NULL);
		}
		else
		{
			return (new);
		}
	}
	return (NULL);
}


grRoom *Gr_GetLeftRoom(gRoom,xleft)

grRoom *gRoom;
int xleft;

{
	int xv,yv;
	grRoom *new;

	xv=gRoom->xv;
	xv--;
	if (xv >= xleft)
	{
		yv=gRoom->yv;
		new=Gr_GetRoom(yv,xv);
		if ((new->status>=6)||(new==gRoom->father))
		{
			return (NULL);
		}
		else
		{
			return (new);
		}
	}
	return (NULL);
}


grRoom *Gr_IsSuccessfulExpansion(father,new,dist)

grRoom *father,*new;
int dist;

{

	if ((new->dist ==0)||(new->dist > dist))
	{
		new->dist=dist;
		new->father=father;
		return (new);
	}
	else
	{
		return (NULL);
	}
}


void Gr_SetTargetsForVNet(vNet,i,dir,xwhois)

grVirtNet *vNet;
int i,dir;
grPrimit *xwhois;

/*
	vNet has been assigned to hole i. In xwhois are marks of sorted
	pins >0 in btn . Here all rooms which are targets for pull outs
	are marked
*/

{

	grSuperNode *current;
	int flag,j,xright,xleft,xo,yo,ytop,ybot;
	grSortedPin *pending;
	grBlock *gBlock;
	grRoom *gRoom;

	flag=0;
	j=0;
	current=vNet->leftNode;

lab1:
	pending=current->contentsPtr->firstxPin;
	while(pending!=NULL)
	{
		j++;
		if ((xwhois+j)->number == 0)
		{
			pending->pinPtr->room->status=5;
		}
		pending=pending->nextxPin;
	}
	if (flag==0)
	{
		flag=1;
		current=vNet->rightNode;
		goto lab1;
	}
	gBlock=(grHeadHolePtr+i)->leftBlockPtr;
	if (gBlock==NULL)
	{
		gBlock=(grHeadHolePtr+i)->rightBlockPtr;
	}

	if (dir==2)
	{
		xright=(grHeadHolePtr+i)->topOrRight_p_x;
		xleft=(grHeadHolePtr+i)->botOrLeft_p_x;
		ybot=gBlock->ypos;
		ytop=ybot+gBlock->height;
		xo=xleft+(xright-xleft)/2;
		gRoom=Gr_GetRoomForPPinPosition(xo,ybot,NORTH_SOUTH_PIN);
		gRoom->status=4;
		gRoom=Gr_GetRoomForPPinPosition(xo,ytop,NORTH_SOUTH_PIN);
		gRoom->status=3;
	}
	if (dir==1)
	{
		ytop=(grHeadHolePtr+i)->topOrRight_p_y;
		ybot=(grHeadHolePtr+i)->botOrLeft_p_y;
		xleft=gBlock->xpos;
		xright=xleft+gBlock->width;
		yo=ybot+(ytop-ybot)/2;
		gRoom=Gr_GetRoomForPPinPosition(xleft,yo,EAST_WEST_PIN);
		gRoom->status=3;
		gRoom=Gr_GetRoomForPPinPosition(xright,yo,EAST_WEST_PIN);
		gRoom->status=4;
	}
}



int Gr_GetDistanceBetweenPoints(x1,y1,x2,y2)

int x1,y1,x2,y2;

{
	int x,y;

	x=x1-x2;
	if (x<0) 
	{
		x= -x;
	}

	y=y1-y2;
	if (y<0)
	{
		y= -y;
	}
	return (x+y);
}


int Gr_GetXPPinInHorzHole(i)

int i; /* hole number */

{
	int xr,xl,xo;

	xr=(grHeadHolePtr+i)->topOrRight_p_x;
	xl=(grHeadHolePtr+i)->botOrLeft_p_x;
	xo=xl+(xr-xl)/2;

	return (xo);
}

int Gr_GetYPPinInHorzHole(i,side)

int i,side;  /* side =0 top, =1 bot */
{
	grBlock *block;
	int y;

	block=(grHeadHolePtr+i)->leftBlockPtr;
	if (block==NULL)
	{
		block=(grHeadHolePtr+i)->rightBlockPtr;
	}

	if (side==0)
	{
		y=block->ypos+block->height;
	}
	else
	{
		y=block->ypos;
	}
	return (y);
}

int Gr_GetYPPinInVertHole(i)

int i;

{
	int yt,yb,yo;

	yt=(grHeadHolePtr+i)->topOrRight_p_y;
	yb=(grHeadHolePtr+i)->botOrLeft_p_y;
	yo=yb+(yt-yb)/2;

	return (yo);
}

int Gr_GetXPPinInVertHole(i,side)

int i,side; /* sode=0 left, =1 right */

{

	grBlock *block;
	int x;

	block=(grHeadHolePtr+i)->leftBlockPtr;
	if (block==NULL)
	{
		block=(grHeadHolePtr+i)->rightBlockPtr;
	}
	if (side==0)
	{
		x=block->xpos;
	}
	else
	{
		x=block->xpos + block->width;
	}

	return (x);
}

