
/* globalSpacer.h --
 *
 *     Wei-ming Dai
 *     (Advising Professor - E. S. Kuh)
 *
 * Copyright (C) 1986 Regents of the University of California
 * All rights reserved.
 *
 * Needs: magic.h, geometry.h, tile.h, tileProp.h
 *
 * rcsid $Header$
 */

#ifndef _GLOBAL_SPACER
#define _GLOBAL_SPACER

#ifndef _MAGIC
int err1 = Need_to_include_magic_header;
#endif _MAGIC

#ifndef _GEOMETRY
int err2 = Need_to_include_geometry_header;
#endif _GEOMETRY

#ifndef _TILES
int err3 = Need_to_include_tile_header;
#endif _TILES

#ifndef _TILEPROP
int err4 = Need_to_include_tileProp_header;
#endif _TILEPROP


typedef enum _SpacingStatus
{
    GS_HC_NOT_FINISHED,
    GS_VC_NOT_FINISHED,
    GS_HC_FINISHED,
    GS_VC_FINISHED,
    GS_HDC_NOT_FINISHED,
    GS_VDC_NOT_FINISHED,
    GS_HDC_FINISHED,
    GS_VDC_FINISHED,
    GS_QUIT
} SpacingStatus;


extern SpacingStatus Gs_HorzCompact(/* planeDataPtr */);
/*
 * PlaneData   *planeDataPtr;
 */

extern SpacingStatus Gs_VertCompact(/* planeDataPtr */);
/*
 * PlaneData   *planeDataPtr;
 */

extern SpacingStatus Gs_HorzDecompact(/* planeDataPtr */);
/*
 * PlaneData   *planeDataPtr;
 */

extern SpacingStatus Gs_VertDecompact(/* planeDataPtr */);
/*
 * PlaneData   *planeDataPtr;
 */

extern void Gs_InitSpaceTile(/*planeDataPtr, parentCellPtr*/);
/*
 * PlaneData   *planeDataPtr;
 * CellMaster  *parentCellPtr;
 */

extern void Gs_ClearHorzSpaceTile(/*planeDataPtr*/);
/*
 * PlaneData   *planeDataPtr;
 */

extern void Gs_ClearVertSpaceTile(/*planeDataPtr*/);
/*
 * PlaneData   *planeDataPtr;
 */

extern BearStatus Gs_CalcCapDenOfBnTile(/*parentCellPtr, bnTilePtr*/);
/*
 * CellMaster  *parentCellPtr;
 * Tile        *bnTilePtr;
 */

extern BearStatus Gs_CalcCapDenOfBnLine(/*bnLinePtr*/);
/*
 * BNLine      *bnLinePtr;
 */

extern BearStatus Gs_CalcCapDenOfTilePlane(/*parentCellPtr*/);
/*
 * CellMaster  *parentCellPtr;
 */

extern BearStatus Gs_CalcCapOfTilePlane(/*parentCellPtr*/);
/*
 * CellMaster  *parentCellPtr;
 */

extern void Gs_SetPause();
extern void Gs_Pause();


/* ------- External global variables for the globalSpacer module ------- */
extern bool gs_Quit;
extern bool gs_DrawRidge;


#endif _GLOBAL_SPACER


