/* globalSpacerInt.h --
 *
 *     Wei-Ming Dai
 *
 * This module performs global spacing (compaction or decompaction)
 * on a given placement.
 *
 * Copyright (C) 1986 Regents of the University of California
 * All rights reserved.
 */

#ifndef _MAGIC
int err1 = Need_to_include_magic_header;
#endif _MAGIC

#ifndef _GEOMETRY
int err2 = Need_to_include_geometry_header;
#endif _GEOMETRY

#ifndef _TILES
int err3 = Need_to_include_tile_header;
#endif _TILES

#ifndef _TILEPROP
int err4 = Need_to_include_tileProp_header;
#endif _TILEPROP

#ifndef _GLOBAL_SPACER
int err5 = Need_to_include_tileProp_header;
#endif _GLOBAL_SPACER

typedef struct _RidgeInfo
{
    int  ridgeWidth;
    Tile *prevTilePtr;
} RidgeInfo;


extern void GsBuildRidgeTileList (/*tilePtr, ridgeHead*/);
/*
Tile       *tilePtr;
LinkedTile *ridgeHead;
*/

extern void GsUpdateCapOfTileList (/* tileList, capOffset */);
/*
Tile *tileList;
int  capOffset;
*/

extern void Gs_HResizeParentCell(/* planeDataPtr, coreInstPtr, resizeDeltaX, 
				    resizeDeltaY, moveDelataX, moveDeltaY */);
/*
PlaneData  *planeDataPtr;
CellInst   *coreInstPtr;
int        resizeDeltaX;
int        resizeDeltaY;
int        moveDeltaX;
int        moveDeltaY;
*/

extern void Gs_HResizeParentCell(/* planeDataPtr, coreInstPtr, resizeDeltaX, 
				    resizeDeltaY, moveDelataX, moveDeltaY */);
/*
PlaneData  *planeDataPtr;
CellInst   *coreInstPtr;
int        resizeDeltaX;
int        resizeDeltaY;
int        moveDeltaX;
int        moveDeltaY;
*/
