
/* cpaInt.h --
 *
 *     Benjamin Chen
 *     Electronics Research Laboratory
 *     University of California, Berkeley
 *
 * Definitions internal to the cpa module.
 *
 * Copyright (C) 1990 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header$
 */

#ifndef _CPA_INT_H
#define _CPA_INT_H /* once-only latch */

#ifdef USE_OCT_CODE
#include "vov.h"
#define KB_EXIT(_X) VOVend(_X);
#else
#include "port.h"
#define KB_EXIT(_X) exit(_X);
#endif /* USE_OCT_CODE */

/* Temporary during development */

#define MALLOC(type, pt, nbytes) \
    (pt) = (type) malloc(nbytes); bzero((char *) (pt), (nbytes)) 

#define FREE(cp) free(cp)

extern void SortNetList();
extern void MergeSort();

/*
 * keyword.c
 */
extern void InitRWTable();
extern int  InRWTable();


/*
 * scanutils.c
 */
extern void yywarning();
extern void yyerror();


/*
 * net2bnet.c
 */
extern BNet *NetToBNets();


extern BChannel     *theChannel;
extern List         *globalPinList;
extern NetClassList *topNetList;
extern NetClassList *bottomNetList;
extern char         *cpaInFiName;       /* Input file name  */
extern char         *cpaOutFiName;      /* Output file name */


extern FILE         *yyin;


#endif _CPA_INT_H

