#include <stdio.h>
#include "cpa.h"
#include "cpaInt.h"
#include "cpaList.h"

/*
 * Benjamin Chen
 * Electronics Research Laboratory
 * University of California, Berkeley
 * September 22, 1990
 */

List *NewEntry(item)
     char *item;
{
    List *newEntry;

    MALLOC(List *, newEntry, sizeof(List));
    L_ITEM(newEntry) = item;
    L_NEXT(newEntry) = (List *) NULL;
    return newEntry;
}

/*
 * AddEntry --
 *     Creates a new list entry for the item, adds that entry to the
 *     front of the list, and returns the resulting list.
 */
List *AddEntry(list, item)
     List *list;
     char *item;
{
    List *newEntry;

    newEntry = NewEntry(item);
    L_NEXT(newEntry) = list;
    return newEntry;
}

/*
 * DeleteEntry --
 *     Deletes the entry at the point in the list specified and assigns the 
 *     pointer to the next entry of the list.
 */
void DeleteEntry(list)
     List **list;
{
    List *nextEntry;

    nextEntry = L_NEXT(*list);

    if (*list == (List *) NULL) {
    fprintf(stderr,
        "DeleteEntry(): Trying to delete from an empty list.\n");
    return;
    }
    FREE(*list);
    *list = nextEntry;
}

/*
 * listLength --
 *     Returns the number of items in a list.
 */
int listLength(list)
     List *list;
{
    int i;

    i = 0;
    while (list != (List *) NULL) {
    i++;
    list = L_NEXT(list);
    }
    return i;
}

