#include <stdio.h>
#include "sort.h"

/*
 * Benjamin Chen
 * Electronics Research Laboratory
 * University of California, Berkeley
 * September 22, 1990
 */

/*
 * mergesort in increasing order
 */

void Divide(p, q)
     Generic **p, **q;
{
    Generic *r;
    *q = *p;
    r = G_NEXT(*p);
    r = G_NEXT(r);
    while (r != G_NIL) {
    r = G_NEXT(r);
    *q = G_NEXT(*q);
    if (r != G_NIL)
        r = G_NEXT(r);
    }
    r = G_NEXT(*q);
    G_NEXT(*q) = G_NIL;
    *q = r;
}

void Merge(p, q, r)
     Generic *p, *q;
     Generic **r;
{
    Generic *s;
    if ((p == G_NIL) || (q == G_NIL)) {
    fprintf(stderr, "MergeSort: Merging empty lists\n");
    return;
    }
    if (KEY(p) >= KEY(q)) {
    *r = p;
    p = G_NEXT(p);
    }
    else {
    *r = q;
    q = G_NEXT(q);
    }
    s = *r;
    while ((p != G_NIL) && (q != G_NIL)) {
    if (KEY(p) >= KEY(q)) {
        G_NEXT(s) = p;
        s = p;
        p = G_NEXT(p);
    }
    else {
        G_NEXT(s) = q;
        s = q;
        q = G_NEXT(q);
    }
    }
    if (p == G_NIL)
    G_NEXT(s) = q;
    else
    G_NEXT(s) = p;
}

void MergeSort(p)
     Generic **p;
{
    Generic *q;

    if (*p != G_NIL) {
    if (G_NEXT(*p) != G_NIL) {
        Divide(p, &q);
        MergeSort(p);
        MergeSort(&q);
        Merge((*p), q, p);
    }
    }
}
