
/* macCellPrim.h --
 *
 *     George Carvalho
 *     Wei-ming Dai
 *     June Wang
 *     (Advising Professor - E. S. Kuh)
 *
 * It defines all the subroutines to retrieve and update the fields of a cell. 
 *
 * Copyright (C) 1986 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header: macCellPrim.h,v 1.2 87/02/07 18:49:55 weiming Exp $
 */

#ifndef _MAC_CELL_PRIM
#define _MAC_CELL_PRIM

extern BearString Mac_GetFileNameOfCellMaster(/* cellMasterPtr */); 
/*
 *  CellMaster  *cellMasterPtr;
 */
  
extern BearString Mac_GetCTreeFileNameOfCellMaster(/* cellMasterPtr */); 
/*
 *  CellMaster  *cellMasterPtr;
 */
  
extern BearString Mac_GetFlexFileNameOfCellMaster(/* cellMasterPtr */); 
/*
 *  CellMaster  *cellMasterPtr;
 */
  
extern BearString Mac_GetPgFileNameOfCellMaster(/* cellMasterPtr */); 
/*
 *  CellMaster  *cellMasterPtr;
 */
  
extern BearString Mac_GetTechFileNameOfCellMaster(/* cellMasterPtr */); 
/*
 *  CellMaster  *cellMasterPtr;
 */
  
extern BearString Mac_GetTimingFileNameOfCellMaster(/* cellMasterPtr */); 
/*
 *  CellMaster  *cellMasterPtr;
 */
  
extern void
Mac_PutFileNameOfCellMaster(/* fileName, cellMasterPtr */); 
/*
 *  BearString  fileName;
 *  CellMaster  *cellMasterPtr;
 */

extern void
Mac_PutCTreeFileNameOfCellMaster(/* ctreeFileName, cellMasterPtr */); 
/*
 *  BearString  ctreeFileName;
 *  CellMaster  *cellMasterPtr;
 */

extern void
Mac_PutFlexFileNameOfCellMaster(/* flexFileName, cellMasterPtr */); 
/*
 *  BearString  flexFileName;
 *  CellMaster  *cellMasterPtr;
 */

extern void
Mac_PutPgFileNameOfCellMaster(/* pgFileName, cellMasterPtr */); 
/*
 *  BearString  pgFileName;
 *  CellMaster  *cellMasterPtr;
 */

extern void
Mac_PutTechFileNameOfCellMaster(/* techFileName, cellMasterPtr */); 
/*
 *  BearString  techFileName;
 *  CellMaster  *cellMasterPtr;
 */

extern void
Mac_PutTimingFileNameOfCellMaster(/* timingFileName, cellMasterPtr */); 
/*
 *  BearString  timingFileName;
 *  CellMaster  *cellMasterPtr;
 */

extern BearString Mac_GetNameOfCellMaster(/* cellMasterPtr */); 
/*
 * CellMaster   *cellMasterPtr;
 */
  
extern BearStatus Mac_PutNameOfCellMaster(/* name, cellMasterPtr */); 
/*
 * BearString   name;
 * CellMaster   *cellMasterPtr;
 */
  
extern BearId Mac_GetIdOfCellMaster(/* cellMasterPtr */);
/*
 * CellMaster *cellMasterPtr;
 */

extern BearString Mac_GetNameOfCellInst(/* cellInstPtr */); 
/*
 * CellInst *cellInstPtr;
 */
  
extern BearStatus Mac_PutNameOfCellInst(/* name, cellInstPtr */); 
/*
 * BearString   name;
 * CellInst *cellInstPtr;
 */

extern bool Mac_IsCellMarked(/* cellInstPtr */);
/*
 * CellInst *cellInstPtr;
 */


extern bool Mac_IsFixedCell(/* cellInstPtr */);
/*
 * CellInst *cellInstPtr;
 */

extern void Mac_MarkCell(/* cellInstPtr */);
/*
 * CellInst *cellInstPtr;
 */

extern void Mac_UnmarkCell(/* cellInstPtr */);
/*
 * CellInst *cellInstPtr;
 */

extern Point *Mac_GetOriginOfCell(/* cellInstPtr */);
/*
 * CellInst *cellInstPtr;
 */

extern void Mac_PutOriginOfCell(/* origin, cellInstPtr */);
/*
 * Point    *origin;
 * CellInst *cellInstPtr;
 */

extern Rect *Mac_GetBBoxOfCell(/* cellInstPtr */);  
/*
 * CellInst *cellInstPtr;
 */

extern void Mac_PutBBoxOfCell(/* bboxPtr, cellInstPtr */);  
/*
 * Rect *bboxPtr;
 * CellInst *cellInstPtr;
 */

extern Rect *Mac_GetBBoxOfCellMaster(/* cellMasterPtr */);  
/*
 * CellMaster   *cellMasterPtr;
 */

extern CellInst *Mac_GetInstOfChipMaster(/* chipMasterPtr */);
/*
 * CellMaster   *chipMasterPtr;
 */

extern CellInst *Mac_GetInstOfCoreMaster(/* coreMasterPtr */);
/*
 * CellMaster   *coreMasterPtr;
 */

extern void Mac_PutBBoxOfCellMaster(/* bboxPtr, cellMasterPtr */);  
/*
 * Rect         *bboxPtr;
 * CellMaster   *cellMasterPtr;
 */

extern OrientVector Mac_GetOrientConstrOfCell(/* cellInstPtr */);
/*
 *  CellInst    *cellInstPtr;
 */

extern void Mac_PutOrientConstrOfCell(/* orientConstr, cellInstPtr */);
/*
 *  OrientVector orientConstr;
 *  CellInst     *cellInstPtr;
 */

extern LinkedPolygon *Mac_GetTranslConstrOfCell(/* cellInstPtr */);
/*
 *  CellInst    *cellInstPtr;
 */

extern void Mac_PutTranslConstrOfCell(/* translConstr, cellInstPtr */);
/*
 *  TranslConstr *translConstr;
 *  CellInst     *cellInstPtr;
 */

extern LinkedLineSeg *Mac_GetBoundaryOfCell (/* cellInstPtr */);
/*
 *  CellInst    *cellInstPtr;
 */

extern void Mac_PutBoundaryOfCell (/* boundary, cellInstPtr */);
/*
 *  LinkedLineSeg   *boundary;
 *  CellInst        *cellInstPtr;
 */

extern BearStatus Mac_MoveBoundaryOfCell(/* transform, cellInstPtr */);
/*
 *  Transform   *transform;
 *  CellInst    *cellInstPtr;
 */

extern CellGroup *Mac_GetGroupOfCell(/* cellInstPtr */);  
/*
 * CellInst *cellInstPtr;
 */

extern RouteCell *Mac_GetRCellListOfCell(/* cellMasterPtr */);  
/*
 * CellMaster   *cellMasterPtr;
 */

extern struct _Net *Mac_GetNetListOfCell(/* cellMasterPtr */);  
/*
 * CellMaster   *cellMasterPtr;
 */

extern PlaneData *Mac_GetCellPlaneOfCell(/* cellMasterPtr */);  
/*
 * CellMaster   *cellMasterPtr;
 */

extern void Mac_PutCellPlaneOfCell(/* planeDataPtr, cellMasterPtr */);  
/*
 * PlaneData    *planeDataPtr;
 * CellMaster   *cellMasterPtr;
 */

extern bool Mac_GetPlacedFlagOfCell(/* cellMasterPtr */);
/*
 * CellMaster   *cellMasterPtr;
 */

extern void Mac_PutPlacedFlagOfCell(/* placedFlag, cellMasterPtr */);
/*
 * bool         placedFlag;
 * CellMaster   *cellMasterPtr;
 */

extern WallJunction *Mac_GetFpgOfCell(/* cellMasterPtr */);  
/*
 * CellMaster   *cellMasterPtr;
 */

extern CellMaster *Mac_GetMasterOfCell(/* cellInstPtr */);
/*
 *  CellInst *cellInstPtr;
 */

extern CellMaster *Mac_GetParentOfCell(/* cellInstPtr */);
/*
 *  CellInst *cellInstPtr;
 */

extern CellMaster  *Mac_GetCellMasterByName(/* name */);
/*
 * BearString name;
 */

extern CellInst  *Mac_GetCellInstByName(/* name */);
/*
 * BearString name;
 */

extern bool Mac_IsNumOfCellsZero(/* cellMasterPtr */);
/*
 * CellMaster   *cellMasterPtr;
 */

extern BearStatus Mac_NumOfCells(/* cellMasterPtr, numPtr */);
/*
 * CellMaster   *cellMasterPtr;
 * int      *numPtr;
 */

extern void Mac_ResizeCell(/* deltaX,deltaY,cellInstPtr */);
/*
 * int deltaX, deltaY;
 * CellInst *cellInstPtr;
 */

#define MIRROR_X 00
#define MIRROR_Y 01

extern void Mac_MirrorCell(/* XorY,cellInstPtr */);
/*
 * int XorY;
 * CellInst *cellInstPtr;
 */

extern void Mac_RotateCell(/* rot90or180or270, cellInstPtr */);
/*
 * int         rot90or180or270;
 * CellInst    *cellInstPtr;
 */

extern void Mac_ReflectCell(/* ref45or135, cellInstPtr */);
/*
 * int         ref45or135;
 * CellInst    *cellInstPtr;
 */

extern void Mac_TransPinDirOfCell(/* trans, cellInstPtr */);
/*
 * Transform   trans;
 * CellInst    *cellInstPtr;
 */

extern BearStatus Mac_GetAbsRectOfCellInst();
extern BearStatus Mac_GetCurrentShape();

#endif _MAC_CELL_PRIM

