
/* macNetPrim.h --
 *
 *      Wei-ming Dai
 *  June Wang
 *
 * It declares all the operations to retrieve and update the primitives.
 *
 * Copyright (C) 1986 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header: macNetPrim.h,v 1.2 87/02/07 18:50:49 weiming Exp $
 */

#ifndef _MAC_NET_PRIM
#define _MAC_NET_PRIM


extern BearString Mac_GetNameOfNet(/*net*/); 
/*
 * Net *net;
 */
  
extern BearStatus Mac_PutNameOfNet(/*name, net*/); 
/*
 * BearString name;
 * Net        *net;
 */

extern BearId Mac_GetIdOfNet(/*net*/); 
/*
 * Net *net;
 */
  
extern void Mac_PutIdOfNet(/*id, net*/); 
/*
 * BearId   id;
 * Net     *net;
 */
  
extern int Mac_GetMaxLengthOfNet(/*net*/); 
/*
 * Net *net;
 */
  
extern void Mac_PutMaxLengthOfNet(/*maxLength, net*/); 
/*
 * int maxLength;
 * Net *net;
 */
  
extern int Mac_GetMinLengthOfNet(/*net*/); 
/*
 * Net *net;
 */
  
extern void Mac_PutMinLengthOfNet(/*minLength, net*/); 
/*
 * int minLength;
 * Net *net;
 */
  
extern int Mac_GetCriticalityOfNet(/*net*/); 
/*
 *  Net *net;
 */
  
extern void Mac_PutCriticalityOfNet(/*criticality, net*/); 
/*
 *  int criticality;
 *  Net *net;
 */
  
extern NetKind Mac_GetKindOfNet(/*net*/); 
/*
 *  Net *net;
 */
  
extern void Mac_PutKindOfNet(/*kind, net*/); 
/*
 *  NetKind kind;
 *  Net     *net;
 */
  
extern LayerVector Mac_GetLayerOfNet(/*net*/); 
/*
 *  Net *net;
 */
  
extern void Mac_PutLayerOfNet(/*layer, net*/); 
/*
 * LayerVector layer;
 * Net         *net;
 */
  
extern  CellMaster *Mac_GetCellOfNet(/* netPtr */);
/*
 * Net *netPtr;
 */

extern bool Mac_IsNumOfNetsZero(/* cellMasterPtr */);
/*
 * CellMaster      *cellMasterPtr;
 */

extern BearStatus Mac_NumOfNets(/* cellMasterPtr, numPtr */);
/*
 * CellMaster      *cellMasterPtr;
 * int *numPtr;
 */

extern bool Mac_GetStatusOfNetInTiPlane(/* netPtr */); 
/*
 * Net  *netPtr;
 */
  
extern void Mac_PutStatusOfNetInTiPlane(/* storedInTiPlane, netPtr */); 
/*
 * bool storedInTiPlane;
 * Net  *netPtr;
 */
  
extern Net *Mac_GetNetByName(/* name */);
/*
 * BearString name;
 */

extern bool Mac_IsGraphValid(/* cellMasterPtr, graph */);
/*
 * CellMaster   *cellMasterPtr;
 * Gt_Graph     graph;
 */

extern Gt_Graph Mac_GetAutoGraphOfNet(/* netPtr */);
/*
 * Net      *netPtr;
 */

extern void Mac_PutAutoGraphOfNet(/* autoGraph, netPtr */);
/*
 * Gt_Graph autoGraph;
 * Net      *netPtr;
 */

extern Gt_Graph Mac_GetUserGraphOfNet(/* netPtr */);
/*
 * Net      *netPtr;
 */

extern void Mac_PutUserGraphOfNet(/* userGraph, netPtr */);
/*
 * Gt_Graph userGraph;
 * Net      *netPtr;
 */

#endif _MAC_NET_PRIM

