
/* macRPin.c --
 *
 *     June Wang
 *     (Advising Professor - E. S. Kuh)
 *
 * This file contains the subroutines to create, insert, and delete
 * routing pins.
 *
 * Copyright (C) 1986 Regents of the University of California
 * All rights reserved.
 */

#ifndef lint
static char rcsid[] = "$Header: macRPin.c,v 1.2 87/02/07 18:54:02 weiming Exp $";
#endif  not lint

#include "bearCopyRight.h"
#include <stdio.h>
#include "magic.h"
#include "malloc.h"
#include "geometry.h"
#include "tile.h"
#include "bear.h"
#include "fpg.h"
#include "gtGraph.h"
#include "tileProp.h"
#include "mac.h"
#include "macInt.h"


/* ---------- Local Functions ---------- */
extern RoutePin *MakeRoutePin();


/*
 * ----------------------------------------------------------------------------
 *
 * MakeRoutePin() --
 *
 * Allocates a pointer for RoutePin, and initializes the fields of the
 * pointer.
 *
 * Results:
 *   The newly allocated pointer.
 *
 * Side effects:
 *   None.
 * ----------------------------------------------------------------------------
 */

/*
Channel interface testing need MakeRoutePin()
static RoutePin *
MakeRoutePin()
*/

RoutePin *
MakeRoutePin()

{
    RoutePin    *routePinPtr;
    int         i;
    RdbPinInfo  *secondPtr;

    MALLOC (RoutePin *, routePinPtr, sizeof (RoutePin));
    routePinPtr->mark = BEAR_UNMARKED;
    routePinPtr->id = 0;
    for (i = 1; i < 8; i++)
    {
    routePinPtr->widthVect[i] = MAXWIDTH;
    }
    routePinPtr->cellPtr = NIL(RouteCell);
    routePinPtr->netPtr = NIL(Net);
    routePinPtr->nextPtr = NIL(RoutePin);
    routePinPtr->BBLTermPtr = NIL(RdbPinInfo);
    secondPtr = routePinPtr->BBLTermPtr;
    secondPtr = secondPtr +1;
    secondPtr = NIL(RdbPinInfo);
    routePinPtr->order = 0;
    routePinPtr->mark = 0;
    return (routePinPtr);
}


/*
 * ----------------------------------------------------------------------------
 *
 * Mac_CreateRPin() --
 *
 * Creates a pointer to RoutePin and connects it up with the given
 * RouteCell.  The pointer to RoutePin is passed back to the calling
 * subroutine as a pointer to a pointer to RoutePin.
 *
 * Results:
 *   BEAR_OK, when done.
 *
 * Side effects:
 *   None.
 * ----------------------------------------------------------------------------
 */

#ifdef USE_DR_CODE
BearStatus
Mac_CreateRPin(rCellPtr, side, rPinPtrPtr)
RouteCell       *rCellPtr;
SideDirection   side;
RoutePin        **rPinPtrPtr;
{
    *rPinPtrPtr = MakeRoutePin();
    (*rPinPtrPtr)->cellPtr = rCellPtr;
    (void) Mac_InsertSidePinOfRCell(rCellPtr, side, *rPinPtrPtr);

    return (BEAR_OK);
}
#endif /* USE_DR_CODE */


