
/* macTech.h --
 *
 *     Wei-ming Dai
 *     (Professor E. S. Kuh)
 *
 * Copyright (C) 1987 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header$
 */

#ifndef _MAC_TECH
#define _MAC_TECH

#define POLY_LAYER      0
#define METAL1_LAYER    1
#define METAL2_LAYER    2
#define METAL3_LAYER    3

#define CONTACT         0
#define M1M2_VIA        1
#define M2M3_VIA        2

typedef struct _LayerRule
{
    int     minWidth;
    double  maxCurrent;
    double  sheetRes;
    double  plateCap;
    double  perimCap;
} LayerRule;

typedef struct _HoleRule
{
    int     size;
    double  current;
    double  res;
    double  cap;
} HoleRule;

typedef struct _LayerLayerRule
{
    int minSpacing;
    int maxParallel;
} LayerLayerRule;

typedef struct _HoleHoleRule
{
    int minSpacing;
} HoleHoleRule;

typedef struct _LayerHoleRule
{
    int minSpacing;
    int minOverlap;
} LayerHoleRule;


extern int Mac_CalcMinPinSpacing();

extern BearStatus Mac_ReadTech(/* fileName */);
/*
 * BearString  fileName;
 */  

extern BearStatus Mac_WriteTech(/* fileName, scale */);
/*
 * BearString  fileName;
 * double      scale;
 */


extern int mac_NumOfLayer;

#endif _MAC_TECH

