/*
 * txOutput.c --
 *
 * 	Handles 'stdout' and 'stderr' output.
 *
 * Copyright (C) 1983 Regents of the University of California
 * All rights reserved.
 */

#ifndef lint
static char sccsid[] = "@(#)txOutput.c	4.5 MAGIC (Berkeley) 11/2/85";
#endif  not lint

#include <stdio.h>
#include <sys/wait.h>
#include "magic.h"
#include "textio.h"
#include "geometry.h"


/*
 * ----------------------------------------------------------------------------
 * TxPrintf:
 *
 *	Magic's own version of printf
 *	(Not any more!)
 *
 * Tricks:
 *	Called with a variable number of arguments -- may not be portable.
 *
 * Results:
 *	None.
 *
 * Side effects:
 *	text appears on stdout 
 *
 * ----------------------------------------------------------------------------
 */ 
 /*VARARGS1*/

void
TxPrintf(format, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20)
char *format;
{
    (void) fprintf(stdout, format, a1, a2, a3, a4, a5, a6, a7, a8, a9, 
	    a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20);
}


/*
 * ----------------------------------------------------------------------------
 * TxFlush:
 *
 *	Flush the standard out and error out.
 *
 * Results:
 *	None.
 *
 * ----------------------------------------------------------------------------
 */ 

void
TxFlush()
{
    
}


/*
 * ----------------------------------------------------------------------------
 * TxError:
 *
 *	Magic's own version of printf, but it goes to stderr
 *      (Not Anymore! AP 22 Dec 85)
 *
 * Tricks:
 *	Called with a variable number of arguments -- may not be portable.
 *
 * Results:
 *	None.
 *
 * Side effects:
 *	text appears on stderr 
 *
 * ----------------------------------------------------------------------------
 */
 /*VARARGS1*/

void
TxError(format, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20)
char *format;
{

    (void) fprintf(stderr, format, a1, a2, a3, a4, a5, a6, a7, a8, a9,
	    a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20);
}

/*
 * ----------------------------------------------------------------------------
 *
 * TxUseMore --
 *
 * 	This procedure forks a "more" process and causes TxError and TxPrintf
 *	to send output through it.
 *
 * Results:
 *	None.
 *
 * Side effects:
 *	A file is opened.  When the caller is finished with output,
 *	it must call TxStopMore to clean up the process.
 *
 * ----------------------------------------------------------------------------
 */

void
TxUseMore()
{}

/*
 * ----------------------------------------------------------------------------
 *
 * TxStopMore --
 *
 * 	Close the pipe connecting us to a "more" process and wait for
 *	the "more" process to die.
 *
 * Results:
 *	None.
 *
 * Side effects:
 *	The connection to more is closed.
 *
 * ----------------------------------------------------------------------------
 */

void
TxStopMore()
{}

char *
TxGetLine(dest, maxChars)
    char *dest;
    int maxChars;
{
    fgets(dest, maxChars, stdin);
}
