/*
 * search.c --
 *
 * Point searching.
 *
 * Copyright (C) 1983 Regents of the University of California
 * All rights reserved.
 */

#ifndef	lint
static	char *sccsid = "@(#)search.c	4.1 MAGIC (Berkeley) 7/4/85";
#endif	not lint

#include <stdio.h>
#include "magic.h"
#include "geometry.h"
#include "tile.h"


/*
 * --------------------------------------------------------------------
 *
 * TiSrPoint --
 *
 * Search for a point.
 *
 * Results:
 *	A pointer to the tile containing the point.
 *	The bottom and left edge of a tile are considered part of
 *	the tile; the top and right edge are not.
 *
 * Side effects:
 *	Updates the hint tile in the supplied plane to point
 *	to the tile found.
 *
 * --------------------------------------------------------------------
 */

Tile *
TiSrPoint(hintTile, plane, point)
    Tile * hintTile;		/* Pointer to tile at which to begin search.
				 * If this is NULL, use the hint tile stored
				 * with the plane instead.
				 */
    Plane * plane;		/* Plane (containing hint tile pointer) */
    register Point * point;	/* Point for which to search */
{
    register Tile *tp = (hintTile) ? hintTile : plane->pl_hint;

    GOTOPOINT(tp, point);
    plane->pl_hint = tp;
    return(tp);
}
