#include "mis.h"
#include "graph_int.h"

lsList
g_get_edges(g)
graph_t g;
{
    if (g == (graph_t) NULL) {
        fail("In g_get_edges: Null graph");
    }
    return(((graph_t_int *) g)->e_list);
}

lsList
g_get_in_edges(v)
vertex_t v;
{
    if (v == (vertex_t) NULL) {
        fail("In g_get_in_edges: Null vertex");
    }
    return(((vertex_t_int *) v)->in_list);
}

lsList
g_get_out_edges(v)
vertex_t v;
{
    if (v == (vertex_t) NULL) {
        fail("In g_get_out_edges: Null vertex");
    }
    return(((vertex_t_int *) v)->out_list);
}

edge_t
g_add_edge(v1,v2)
vertex_t v1,v2;
{
    edge_t_int *edge;
    lsHandle handle;
    vertex_t_int *from = (vertex_t_int *) v1;
    vertex_t_int *to = (vertex_t_int *) v2;

    if (v1 == (vertex_t) NULL || v2 == (vertex_t) NULL) {
        fail("In g_add_edge: Null vertex");
    }
    if (from->g != to->g) {
        fail("In g_add_edge: Edge connects different graphs");
    }
    edge = ALLOC(edge_t_int,1);
    (void) lsNewEnd(from->g->e_list,(lsGeneric) edge,&handle);
    edge->user_data = (gGeneric) NULL;
    edge->from = from;
    edge->to = to;
    edge->id = g_unique_id++;
    edge->handle = handle;
    (void) lsNewEnd(from->out_list,(lsGeneric) edge,LS_NH);
    (void) lsNewEnd(to->in_list,(lsGeneric) edge,LS_NH);

    return((edge_t) edge);
}

void
g_delete_edge(e,f_free_e)
edge_t e;
void (*f_free_e)();
{
    lsGeneric junk;
    edge_t_int *edge = (edge_t_int *) e;

    if (e == (edge_t) NULL) {
        fail("In g_delete_edge: Null edge");
    }
    del_from_list(edge->from->out_list,(lsGeneric) edge);
    del_from_list(edge->to->in_list,(lsGeneric) edge);
    (void) lsRemoveItem(edge->handle,&junk);
    if (f_free_e != (void (*)()) NULL) {
        (*f_free_e)(edge->user_data);
    }
    FREE(edge);
}

graph_t
g_edge_graph(e)
edge_t e;
{
    if (e == (edge_t) NULL) {
        fail("In g_edge_graph: Null edge");
    }
    return((graph_t) (((edge_t_int *) e)->to->g));
}

vertex_t
g_e_source(e)
edge_t e;
{
    if (e == (edge_t) NULL) {
        fail("In g_e_source: Null edge");
    }
    return((vertex_t) (((edge_t_int *) e)->from));
}

vertex_t
g_e_dest(e)
edge_t e;
{
    if (e == (edge_t) NULL) {
        fail("In g_e_dest: Null edge");
    }
    return((vertex_t) (((edge_t_int *) e)->to));
}

