#include "mis.h"
#include "graph_int.h"
#include "graph_static_int.h"

edge_t 
g_add_edge_static(v1, v2)
vertex_t v1, v2;
{
    edge_t e;
    g_field_t *gf;

    if (v1 == (vertex_t) NULL || v2 == (vertex_t) NULL) {
        fail("In g_add_edge_static: Null vertex");
    }
    e = g_add_edge(v1, v2);
    gf = (g_field_t *) ((edge_t_int *) e)->to->g->user_data;
    e->user_data = (gGeneric) ALLOC(gGeneric, gf->num_e_slots);
    return(e);
}


void
g_delete_edge_static(e, f_free_e)
edge_t e;
void (*f_free_e)();
{
    if (e == (edge_t) NULL) {
        fail("In g_delete_edge_static: Null edge");
    }
    if (f_free_e != (void (*)()) NULL) {
        (*f_free_e)(e->user_data);
    }
    FREE(e->user_data);
    g_delete_edge(e,(void (*)()) NULL);
}


void
g_set_e_slot_static(e, i, val)
edge_t e;
int i;
gGeneric val;
{
    if (e == (edge_t) NULL) {
        fail("In g_set_e_slot_static: Null edge");
    }
    ((gGeneric *) e->user_data)[i] = val;
}


gGeneric 
g_get_e_slot_static(e, i)
edge_t e;
int i;
{
    if (e == (edge_t) NULL) {
        fail("In g_get_e_slot_static: Null edge");
    }
    return((gGeneric *) e->user_data)[i];
}


void
g_copy_e_slots_static(e1,e2,f_copy_e)
edge_t e1, e2;
gGeneric (*f_copy_e)();
{
    int n;
    gGeneric slots1,*slots2;

    if (e1 == (edge_t) NULL || e2 == (edge_t) NULL) {
        fail("In g_copy_e_slots_static: Null edge");
    }
    n = ((g_field_t *) ((edge_t_int *) e1)->to->g->user_data)->num_e_slots;

    if (n != ((g_field_t *) ((edge_t_int *) e2)->to->g->user_data)->num_e_slots) {
        fail("In g_copy_e_slots_static: Edges have differing numbers of slots");
    }
    slots1 = e1->user_data;
    slots2 = (gGeneric *) e2->user_data;
    if (f_copy_e == (gGeneric (*)()) NULL) {
        for (n--; n >= 0; n--) {
	    slots2[n] = ((gGeneric *) slots1)[n];
	}
    }
    else {
        FREE(slots2);
        e2->user_data = (*f_copy_e)(slots1);
    }
}
