#include "mis.h"
#include "graph_int.h"

lsList
g_get_vertices(g)
graph_t g;
{
    if (g == (graph_t) NULL) {
        fail("In g_get_vertices: Null graph");
    }
    return(((graph_t_int *) g)->v_list);
}

vertex_t
g_add_vertex(g)
graph_t g;
{
    lsHandle handle;
    vertex_t_int *vert;
    graph_t_int *graph = (graph_t_int *) g;

    if (g == (graph_t) NULL) {
        fail("In g_add_vertex: Null graph");
    }
    vert = ALLOC(vertex_t_int,1);
#ifdef OLD_LIST_CODE
    if (lsNewEnd(graph->v_list,(lsGeneric) vert,&handle) != LS_OK) {
        fail("In g_add_vertex: Can't add vertex");
    }    
#else
    lsNewEnd(graph->v_list,(lsGeneric) vert,&handle);
#endif OLD_LIST_CODE
    vert->user_data = (gGeneric) NULL;
    vert->g = graph;
    vert->in_list = lsCreate();
    vert->out_list = lsCreate();
    vert->id = g_unique_id++;
    vert->handle = handle;
    return((vertex_t) vert);
}

void
del_from_list(list,item)
lsList list;
lsGeneric item;
{
    lsGen gen;
    lsGeneric looking,dummy;
    lsHandle handle;

    gen = lsStart(list);
    while (lsNext(gen,&looking,&handle) != LS_NOMORE) {
        if (item == looking) {
#ifdef OLD_LIST_CODE
			if (lsRemoveItem(handle,&dummy) != LS_OK) {
				fail("In del_from_list: Can't remove edge");
			}
#else
	    	lsRemoveItem(handle,&dummy);
#endif OLD_LIST_CODE
	    	break;
		}
    }
    (void) lsFinish(gen);
}

void
g_delete_vertex(v,f_free_v,f_free_e)
vertex_t v;
void (*f_free_v)();
void (*f_free_e)();
{
    edge_t e;
    lsGeneric junk;
    lsGen gen;

    if (v == (vertex_t) NULL) {
        fail("In g_delete_vertex: Null vertex");
    }
    if (f_free_v != (void (*)()) NULL) {
        (*f_free_v)(v->user_data);
    }
    foreach_in_edge (v,gen,e) {
        del_from_list(((edge_t_int *) e)->from->out_list,(lsGeneric) e);
	if (f_free_e != (void (*)()) NULL) {
	    (*f_free_e)(e->user_data);
	}
#ifdef OLD_LIST_CODE
	if (lsRemoveItem(((edge_t_int *) e)->handle,&junk) != LS_OK) {
	    fail("In g_delete_vertex: Can't remove edge from graph");
	}
#else
	lsRemoveItem(((edge_t_int *) e)->handle,&junk);
#endif OLD_LIST_CODE
	FREE(e);
    }
    foreach_out_edge (v,gen,e) {
        del_from_list(((edge_t_int *) e)->to->in_list,(lsGeneric) e);
	if (f_free_e != (void (*)()) NULL) {
	    (*f_free_e)(e->user_data);
	}
#ifdef OLD_LIST_CODE
	if (lsRemoveItem(((edge_t_int *) e)->handle,&junk) != LS_OK) {
	    fail("In g_delete_vertex: Can't remove edge from graph");
	}
#else
	lsRemoveItem(((edge_t_int *) e)->handle,&junk);
#endif OLD_LIST_CODE
	FREE(e);
    }
    (void) lsDestroy(((vertex_t_int *) v)->out_list,(void (*)()) NULL);
    (void) lsDestroy(((vertex_t_int *) v)->in_list,(void (*)()) NULL);
    (void) lsRemoveItem(((vertex_t_int *) v)->handle,&junk);
    FREE(v);
}

graph_t
g_vertex_graph(v)
vertex_t v;
{
    if (v == (vertex_t) NULL) {
        fail("In g_vertex_graph: Null vertex");
    }
    return((graph_t) ((vertex_t_int *) v)->g);
}

