
/* nplArrays.c --
 *
 * Massoud Pedram
 *
 */

#include "bearCopyRight.h"
#include "newPInt.h"


Ncl_ShapeSet *((*(nplShapeFuncArray[NPL_MAX_PATTERNS]))()) =
{
   NplShapeFunc0, NplShapeFunc1, NplShapeFunc2,
   NplShapeFunc3, NplShapeFunc4, NplShapeFunc5,
   NplShapeFunc6, NplShapeFunc7, NplShapeFunc8,
   NplShapeFunc9, NplShapeFunc10,
};

void    ((*(nplTransOfChildrenFuncArray[NPL_MAX_PATTERNS]))()) =
{
   Npl_TransOfChildrenFunc0, Npl_TransOfChildrenFunc1, Npl_TransOfChildrenFunc2, 
   Npl_TransOfChildrenFunc3, Npl_TransOfChildrenFunc4, Npl_TransOfChildrenFunc5, 
   Npl_TransOfChildrenFunc6, Npl_TransOfChildrenFunc7, Npl_TransOfChildrenFunc8, 
   Npl_TransOfChildrenFunc9, Npl_TransOfChildrenFunc10,  
};

void    ((*(nplDimOfNodeFuncArray[NPL_MAX_PATTERNS]))()) =
{
   Npl_DimOfNodeFunc0, Npl_DimOfNodeFunc1, Npl_DimOfNodeFunc2, Npl_DimOfNodeFunc3, 
   Npl_DimOfNodeFunc4, Npl_DimOfNodeFunc5, Npl_DimOfNodeFunc6, Npl_DimOfNodeFunc7, 
   Npl_DimOfNodeFunc8, Npl_DimOfNodeFunc9, Npl_DimOfNodeFunc10, 
};

void    ((*(nplRoomExtOfNodeFuncArray[NPL_MAX_PATTERNS]))()) =
{
   NplRoomExtOfNodeFunc0, NplRoomExtOfNodeFunc1, NplRoomExtOfNodeFunc2, 
   NplRoomExtOfNodeFunc3,  NplRoomExtOfNodeFunc4, NplRoomExtOfNodeFunc5, 
   NplRoomExtOfNodeFunc6, NplRoomExtOfNodeFunc7, NplRoomExtOfNodeFunc8,
   NplRoomExtOfNodeFunc9, NplRoomExtOfNodeFunc10, 
};


/* arrays of characteristic numbers of templates */
  
int  npl_FactArray [NPLMAX_ROOMS] =
{ 1,2,6,24,120 };

int  npl_FloorplanSizeArray [NPL_MAX_PATTERNS] =
{ 1,2,3,3,4,4,4,4,4,4,4 };

int  nplSymmetric [NPL_MAX_PATTERNS] =
{ TRUE, TRUE, FALSE, TRUE, TRUE, FALSE, FALSE, TRUE, FALSE, FALSE, TRUE };

int nplGoalAssignTable [NPLMAX_ORIENT][NPLMAX_GOALS] =
{
    {NORTH, WEST, SOUTH, EAST},
    {EAST, NORTH, WEST, SOUTH},
    {SOUTH, EAST, NORTH, WEST},
    {WEST, SOUTH, EAST, NORTH}
};
  
int nplDirectionTable [8][4] =
{
    {NORTH, WEST, SOUTH, EAST},
    {SOUTH, WEST, NORTH, EAST},
    {SOUTH, EAST, NORTH, WEST},
    {NORTH, EAST, SOUTH, WEST},
    {EAST, SOUTH, WEST, NORTH},
    {EAST, NORTH, WEST, SOUTH},
    {WEST, NORTH, EAST, SOUTH},
    {WEST, SOUTH, EAST, NORTH}
};
  
int npl_LableTable [NPLMAX_ROOM_ASSIGN][NPLMAX_ROOMS] =
{
    {0, 1, 2, 3, 4},
    {1, 0, 2, 3, 4},
    {0, 2, 1, 3, 4},
    {1, 2, 0, 3, 4},
    {2, 0, 1, 3, 4},
    {2, 1, 0, 3, 4},

    {0, 1, 3, 2, 4},
    {1, 0, 3, 2, 4},
    {0, 2, 3, 1, 4},
    {1, 2, 3, 0, 4},
    {2, 0, 3, 1, 4},
    {2, 1, 3, 0, 4},

    {0, 3, 1, 2, 4},
    {1, 3, 0, 2, 4},
    {0, 3, 2, 1, 4},
    {1, 3, 2, 0, 4},
    {2, 3, 0, 1, 4},
    {2, 3, 1, 0, 4},

    {3, 0, 1, 2, 4},
    {3, 1, 0, 2, 4},
    {3, 0, 2, 1, 4},
    {3, 1, 2, 0, 4},
    {3, 2, 0, 1, 4},
    {3, 2, 1, 0, 4},


    {0, 1, 2, 4, 3},
    {1, 0, 2, 4, 3},
    {0, 2, 1, 4, 3},
    {1, 2, 0, 4, 3},
    {2, 0, 1, 4, 3},
    {2, 1, 0, 4, 3},

    {0, 1, 3, 4, 2},
    {1, 0, 3, 4, 2},
    {0, 2, 3, 4, 1},
    {1, 2, 3, 4, 0},
    {2, 0, 3, 4, 1},
    {2, 1, 3, 4, 0},

    {0, 3, 1, 4, 2},
    {1, 3, 0, 4, 2},
    {0, 3, 2, 4, 1},
    {1, 3, 2, 4, 0},
    {2, 3, 0, 4, 1},
    {2, 3, 1, 4, 0},

    {3, 0, 1, 4, 2},
    {3, 1, 0, 4, 2},
    {3, 0, 2, 4, 1},
    {3, 1, 2, 4, 0},
    {3, 2, 0, 4, 1},
    {3, 2, 1, 4, 0},


    {0, 1, 4, 2, 3},
    {1, 0, 4, 2, 3},
    {0, 2, 4, 1, 3},
    {1, 2, 4, 0, 3},
    {2, 0, 4, 1, 3},
    {2, 1, 4, 0, 3},

    {0, 1, 4, 3, 2},
    {1, 0, 4, 3, 2},
    {0, 2, 4, 3, 1},
    {1, 2, 4, 3, 0},
    {2, 0, 4, 3, 1},
    {2, 1, 4, 3, 0},

    {0, 3, 4, 1, 2},
    {1, 3, 4, 0, 2},
    {0, 3, 4, 2, 1},
    {1, 3, 4, 2, 0},
    {2, 3, 4, 0, 1},
    {2, 3, 4, 1, 0},

    {3, 0, 4, 1, 2},
    {3, 1, 4, 0, 2},
    {3, 0, 4, 2, 1},
    {3, 1, 4, 2, 0},
    {3, 2, 4, 0, 1},
    {3, 2, 4, 1, 0},


    {0, 4, 1, 2, 3},
    {1, 4, 0, 2, 3},
    {0, 4, 2, 1, 3},
    {1, 4, 2, 0, 3},
    {2, 4, 0, 1, 3},
    {2, 4, 1, 0, 3},

    {0, 4, 1, 3, 2},
    {1, 4, 0, 3, 2},
    {0, 4, 2, 3, 1},
    {1, 4, 2, 3, 0},
    {2, 4, 0, 3, 1},
    {2, 4, 1, 3, 0},

    {0, 4, 3, 1, 2},
    {1, 4, 3, 0, 2},
    {0, 4, 3, 2, 1},
    {1, 4, 3, 2, 0},
    {2, 4, 3, 0, 1},
    {2, 4, 3, 1, 0},

    {3, 4, 0, 1, 2},
    {3, 4, 1, 0, 2},
    {3, 4, 0, 2, 1},
    {3, 4, 1, 2, 0},
    {3, 4, 2, 0, 1},
    {3, 4, 2, 1, 0},


    {4, 0, 1, 2, 3},
    {4, 1, 0, 2, 3},
    {4, 0, 2, 1, 3},
    {4, 1, 2, 0, 3},
    {4, 2, 0, 1, 3},
    {4, 2, 1, 0, 3},

    {4, 0, 1, 3, 2},
    {4, 1, 0, 3, 2},
    {4, 0, 2, 3, 1},
    {4, 1, 2, 3, 0},
    {4, 2, 0, 3, 1},
    {4, 2, 1, 3, 0},

    {4, 0, 3, 1, 2},
    {4, 1, 3, 0, 2},
    {4, 0, 3, 2, 1},
    {4, 1, 3, 2, 0},
    {4, 2, 3, 0, 1},
    {4, 2, 3, 1, 0},

    {4, 3, 0, 1, 2},
    {4, 3, 1, 0, 2},
    {4, 3, 0, 2, 1},
    {4, 3, 1, 2, 0},
    {4, 3, 2, 0, 1},
    {4, 3, 2, 1, 0}
};

/* The next array contains for every floorplan and for all the rooms
 * in the floorplan all those rooms, that are north, west, south and east
 * (in this sequence) of the first room. */

char *nplInDir[][MAX_CHILDREN][4] =
{
{{"N","W","S","E"}},
{{"N","W","S","1E"},{"N","0W","S","E"}},
{{"N","W","S","12E"},{"2N","0W","S","E"},{"N","0W","1S","E"}},
{{"N","W","S","12E"},{"N","0W","S","2E"},{"N","01W","S","E"}},
{{"23N","W","S","13E"},{"23N","02W","S","E"},{"N","W","01S","13E"},
 {"N","02W","01S","E"}},
{{"N","W","S","123E"},{"3N","0W","S","2E"},{"3N","01W","S","E"},
 {"N","0W","12S","E"}},
{{"N","W","S","123E"},{"23N","0W","S","E"},{"N","0W","1S","3E"},
 {"N","02W","1S","E"}},
{{"N","W","S","123E"},{"2N","0W","S","3E"},{"N","0W","1S","3E"},
 {"N","012W","S","E"}},
{{"N","W","S","123E"},{"N","0W","S","23E"},{"3N","01W","S","E"},
 {"N","01W","2S","E"}},
{{"N","W","S","123E"},{"23N","0W","S","E"},{"3N","0W","1S","E"},
 {"N","0W","12S","E"}},
{{"N","W","S","123E"},{"N","0W","S","23E"},{"N","01W","S","3E"},
 {"N","012W","S","E"}}
};

/* The next array contains for all the floorplans and for every room
 * in a floorplan lists of rooms that are adjacent to this room in
 * northern, western, southern, eastern direction (in this sequence). */

char *nplNeighb[][MAX_CHILDREN][4] =
{
{{"N","W","S","E"}},
{{"N","W","S","1"},{"N","0","S","E"}},
{{"N","W","S","12"},{"2","0","S","E"},{"N","0","1","E"}},
{{"N","W","S","1"},{"N","0","S","2"},{"N","1","S","E"}},
{{"2","W","S","1"},{"3","0","S","E"},{"N","W","0","3"},{"N","2","1","E"}},
{{"N","W","S","13"},{"3","0","S","2"},{"3","1","S","E"},{"N","0","12","E"}},
{{"N","W","S","12"},{"23","0","S","E"},{"N","0","1","3"},{"N","2","1","E"}},
{{"N","W","S","12"},{"2","0","S","3"},{"N","0","1","3"},{"N","12","S","E"}},
{{"N","W","S","1"},{"N","0","S","23"},{"3","1","S","E"},{"N","1","2","E"}},
{{"N","W","S","123"},{"2","0","S","E"},{"3","0","1","E"},{"N","0","2","E"}},
{{"N","W","S","1"},{"N","0","S","2"},{"N","1","S","3"},{"N","2","S","E"}}
};



char *nplRoutingInfo[] = {
"template 0",
"0N 0 1.0",
"0S 0 1.0",
"0E 0 1.0",
"0W 0 1.0",
"template 1",
"0N 5 0.7",
"1Wd 0Eu 0Sv 01u 0Wu",
"0S 5 0.8",
"1Wd 0Eu 0Nv 0Wu 01u",
"0W 4 0.8",
"0Su 0Nu 01v 0Ev",
"01 9 1.2",
"01a 0Eb 1Wb 0Nu 0Wv 0Su 1Nu 1Su 1Ev",
"1N 5 0.7",
"0Ed 1Wu 1Sv 01u 1Eu",
"1S 5 0.8",
"0Ed 1Wu 01u 1Nv 1Eu",
"1E 4 0.8",
"01v 1Nu 1Su 1Wv",
"template 2",
"0W 5 0.8",
"01v 02v 0Su 0Nu 0Ev",
"0N 6 0.8",
"2Wl 0Sv 0Wu 01w 02x 0Eu",
"0S 6 0.8",
"1Wl 0Nv 0Wu 01x 02w 0Eu",
"01 c 0.5",
"0Eg 1Wj 01e 02f 1Nu 2Sd 0Su 0Nw 0Wv 12u 1Ev 1Su",
"02 c 0.5",
"0Eg 2Wj 01f 02e 1Nd 2Su 0Nu 0Sw 0Wv 12u 2Ev 2Nu",
"1S 6 0.8",
"0Ei 1Wx 12v 01u 1Eu 1Nv",
"12 c 1.0",
"0Eh 12a 2Sb 1Nb 1Sv 2Nv 1Eu 2Eu 01u 02u 1Ww 2Ww",
"2N 6 0.8",
"0Ei 2Wx 12v 02u 2Eu 2Sv",
"1E 6 0.8",
"1Nu 2Sd 01v 1Su 12u 1Wv",
"2E 6 0.8",
"1Nd 2Su 02v 2Nu 12u 2Wv",
"template 3",
"0W 5 0.8",
"01v 0Nu 0Su 02v 0Ev",
"0N 7 0.7",
"0Eu 1Wd 2Wd 02u 0Sv 01u 0Wu",
"0S 7 0.8",
"0Eu 1Wd 2Wd 02u 01u 0Nv 0Wu",
"01 b 1.2",
"0Eb 1Wb 01a 02b 0Wv 0Nu 0Su 1Nu 1Su 12v 1Ev",
"1N 8 0.7",
"0Ed 1Wu 2Wd 02d 1Eu 1Sv 01u 12u",
"1S 8 0.8",
"0Ed 1Wu 2Wd 02d 1Eu 1Nv 01u 12u",
"12 b 1.2",
"1Eb 2Wb 12a 02b 01v 2Ev 1Nu 1Su 2Nu 2Su 1Wv",
"2N 7 0.7",
"2Wu 1Ed 0Ed 02u 2Sv 12u 2Eu",
"2S 7 0.8",
"2Wu 1Ed 0Ed 02u 2Nv 12u 2Eu",
"2E 5 0.8",
"12v 2Nu 2Su 02v 2Wv",
"template 4",
"0W 7 0.8",
"0Nu 2Sd 01v 0Su 02u 0Ev 03v",
"2W 7 0.8",
"0Nd 2Su 02u 2Nu 12v 2Ev 23v",
"0S 7 0.8",
"0Eu 1Wd 0Nv 03v 02v 01u 0Wu",
"02 f 0.7",
"02a 03s 12s 0Nb 2Sb 1Wd 3Wd 0Eu 2Eu 0Sv 2Nv 01u 23u 0Wu 2Wu",
"2N 7 0.8",
"2Eu 3Wd 02v 12v 2Sv 2Wu 23u",
"01 f 0.6",
"01a 03s 12s 0Eb 1Wb 0Nu 1Nu 2Sd 3Sd 0Wv 1Ev 02u 13u 0Su 1Su",
"23 f 0.6",
"23a 12s 03s 2Su 3Su 0Nd 1Nd 2Eb 3Wb 2Wv 3Ev 2Nu 3Nu 02u 13u",
"03 0 1.0 ???",
"1S 7 0.8",
"0Ed 1Wu 1Nv 12v 13v 1Eu 01u",
"13 f 0.7",
"13a 12s 03s 1Nb 3Sb 1Wu 3Wu 0Ed 2Ed 1Sv 3Nv 1Eu 3Eu 23u 01u",
"3N 7 0.8",
"2Ed 3Wu 3Sv 03v 13v 23u 3Eu",
"1E 7 0.8",
"1Nu 3Sd 01v 12v 1Wv 13u 1Su",
"3E 7 0.8",
"1Nd 3Su 3Wv 23v 03v 3Nu 13u",
"template 5",
"0W 6 0.8",
"0Nu 0Su 03v 01v 02v 0Ev",
"0N 7 0.8",
"3Wl 0Wu 0Sv 03x 01w 02w 0Eu",
"0S 8 0.8",
"1Wl 2Wl 0Wu 0Nv 03w 01x 02x 0Eu",
"01 e 0.7",
"01e 02g 03f 0Eg 1Nx 3Si 1Wj 0Wv 0Nw 0Su 1Su 1Ev 12v 13u",
"03 e 0.7",
"01f 03e 02g 0Eg 1Nl 3Wj 3Su 23w 3Ev 3Nu 0Sw 0Wv 0Nu 13x",
"1S 9 0.8",
"02d 2Wr 13v 12u 01u 1Eu 1Wu 0Ei 1Nv",
"13 f 0.8",
"02h 0Eh 13e 23f 1Nj 1Eu 3Sg 03u 01u 12u 1Sv 3Ew 3Nv 1Wv 3Wv",
"3N 7 0.8",
"0Ei 3Wx 03u 3Eu 13v 23v 3Sv",
"12 e 1.0",
"12a 3Sh 02b 1Eb 2Wb 13u 1Su 01v 1Wv 2Su 23u 2Ev 2Nw 1Nw",
"2S 8 0.8",
"02u 0Ei 1Ed 2Wx 23v 12u 2Eu 2Nv",
"23 f 0.8",
"23e 13f 0Eh 1Ed 02u 3Sg 2Nj 2Sv 12u 2Eu 2Ww 03w 3Nv 3Eu 3Ww",
"2E 7 0.8",
"2Nx 3Si 23u 2Su 12v 02v 2Wv",
"3E 7 0.8",
"2Nl 3Su 3Nu 3Wv 03v 13w 23x",
"template 6",
"0W 6 0.8",
"0Nu 0Su 01v 02v 03v 0Ev",
"0N 8 0.8",
"2Wl 3Wl 0Eu 0Wu 02x 01w 03u 0Sv",
"0S 7 0.8",
"1Wl 0Nv 0Wu 01x 02w 03w 0Eu",
"01 e 0.7",
"02f 01e 03g 0Eg 2Sl 1Nu 0Nw 0Wv 0Su 1Wj 1Ev 1Sx 12u 13w",
"02 e 0.7",
"02e 03g 01f 0Eg 2Sx 1Ni 12u 2Nu 0Nu 0Sw 0Wv 23v 2Ev 2Wj",
"1S 7 0.8",
"0Ei 1Wx 01u 1Eu 12v 13v 1Nv",
"12 f 0.8",
"03h 0Eh 12e 13f 2Sj 2Eu 1Ng 01u 1Ew 1Sv 02u 2Wv 23u 1Ww 2Nw",
"2N 9 0.8",
"03d 3Wr 2Eu 2Wu 02u 23u 12v 2Sv 0Ei",
"23 e 1.0",
"23a 1Nh 03b 2Eb 3Wb 02v 12u 2Nu 2Sw 3Nu 13u 3Ev 3Sw 2Wv",
"13 f 0.8",
"13e 12f 0Eh 2Ed 03u 1Ng 3Sj 01w 1Sv 1Eu 1Ww 3Nv 3Eu 3Ww 23u",
"3N 8 0.8",
"03u 0Ei 2Ed 3Wx 3Eu 23u 13v 3Sv",
"1E 7 0.8",
"3Sl 1Nu 13x 12w 01v 1Wv 1Su",
"3E 7 0.8",
"3Sx 2Ni 3Nu 13u 3Wv 23v 03v",
"template 7",
"0W 6 0.8",
"0Nu 0Su 0Ev 01v 02v 03v",
"0N 8 0.8",
"2Wl 3Wd 0Ec 0Wu 0Sv 02x 01w 03u",
"0S 8 0.8",
"1Wl 3Wd 03u 0Eu 0Nv 0Wu 01x 02w",
"01 f 0.7",
"01e 02f 03g 0Ej 1Nu 2Sd 1Wj 0Wv 0Sx 0Nw 1Su 1Ev 12u 13v 3Wm",
"02 f 0.7",
"02e 01f 03g 0Ej 1Nd 2Su 2Wj 0Wv 0Nx 0Sw 2Nu 2Ev 12u 23v 3Wm",
"1S 9 0.8",
"03i 0Ec 3Wd 1Wx 1Ex 01u 12v 13u 1Nv",
"12 g 1.0",
"12a 03h 1Nb 2Sb 1Sv 2Nv 02u 01u 23u 13u 2Ew 2Ww 1Ew 1Ww 3Wk 0Ek",
"2N 9 0.8",
"03i 0Ec 3Wd 2Wx 2Ex 02u 23u 12v 2Sv",
"13 f 0.7",
"13e 23f 03g 3Wj 1Nu 2Sd 1Ej 1Su 1Wv 3Ev 3Sx 3Nw 0Em 01v 12u",
"23 f 0.7",
"23e 13f 03g 3Wj 1Nd 2Su 2Ej 2Nu 2Wv 3Ev 3Nx 3Sw 0Em 02v 12u",
"3S 8 0.8",
"0Ed 1El 03u 3Wu 3Nv 3Eu 13x 23w",
"3N 8 0.8",
"0Ed 2El 03u 3Wu 3Sv 3Eu 13w 23x",
"3E 6 0.8",
"3Su 3Nu 03v 13v 23v 3Wv",
"template 8",
"0W 6 0.8",
"0Su 0Nu 01v 02v 03v 0Ev",
"0N 8 0.8",
"03x 0Eu 1Wd 3Wl 0Wu 0Sv 01u 02w",
"0S 8 0.8",
"02x 0Eu 1Wd 2Wl 0Wu 01u 03w 0Nv",
"01 d 1.0",
"01a 0Eb 1Wb 02b 03b 0Nu 0Su 0Wv 1Nu 1Su 1Ev 12v 13v",
"1N 9 0.8",
"03l 0Ed 1Wu 3Wl 1Eu 01u 13x 12w 1Sv",
"1S 9 0.8",
"02l 0Ed 1Wu 2Wl 1Eu 01u 12x 1Nv 13w",
"12 e 0.7",
"12e 13f 02j 1Eg 2Wj 2Nu 3Sd 01v 1Su 1Nw 1Wv 23u 2Su 2Ev",
"13 e 0.7",
"12f 13e 03j 1Eg 3Wj 2Nd 3Su 01v 1Nu 1Sw 1Wv 23u 3Nu 3Ev",
"2S 8 0.8",
"2Wx 0Ed 02u 1Ei 2Nv 2Eu 12u 23v",
"23 e 1.0",
"23a 1Eh 2Nb 3Sb 2Eu 3Eu 2Ww 3Ww 2Sv 3Nv 02w 03w 12u 13u",
"3N 8 0.8",
"3Wx 0Ed 03u 1Ei 3Sv 3Eu 13u 23v",
"2E 7 0.8",
"2Nu 3Sd 2Su 2Wv 02v 12v 23u",
"3E 7 0.8",
"2Nd 3Su 3Nu 3Wv 03v 13v 23u",
"template 9",
"0W 6 0.8",
"0Nu 0Su 01v 02v 03v 0Ev",
"0N 8 0.8",
"2Wd 3Wl 0Eu 0Sv 0Wu 03x 02u 01w",
"0S 8 0.8",
"2Wd 1Wl 0Eu 0Nv 0Wu 01x 02u 03w",
"01 f 0.7",
"01e 02f 03n 0Ef 13u 1Nu 2Sd 3Sd 0Wv 0Su 0Nv 1Su 1Wj 1Ev 12u",
"02 g 0.7",
"02e 01f 03f 0Ee 1Nd 13d 3Sd 2Su 2Nu 2Wj 2Ev 12u 23u 0Nu 0Su 0Wv",
"03 f 0.7",
"03e 01n 02f 0Ef 13u 1Nd 2Nd 3Su 0Wv 0Nu 0Sv 3Nu 3Wj 3Ev 23u",
"1S 7 0.8",
"0Eq 1Wx 1Nv 1Eu 12v 13v 01u",
"12 e 1.0",
"0Ep 12a 13b 1Nb 2Sb 1Sv 1Eu 1Ww 01u 2Eu 2Wu 2Nv 02u 23v",
"23 e 1.0",
"0Ep 23a 13b 3Sb 2Nb 2Wu 3Nv 3Eu 03u 2Eu 3Ww 2Sv 02u 12v",
"3N 7 0.8",
"0Eq 3Wx 3Sv 3Eu 03u 13v 23v",
"1E 8 0.8",
"1Nu 2Sd 3Sd 13u 1Su 1Wv 01v 12u",
"2E 9 0.8",
"2Nu 2Su 3Sd 1Nd 13d 2Wv 02v 12u 23u",
"3E 8 0.8",
"1Nd 2Nd 3Su 13u 3Nu 3Wv 03v 23u",
"template 10",
"0W 6 1.0",
"01v 0Nu 0Su 02v 03v 0Ev",
"0S 9 0.8",
"0Eu 1Wd 2Wd 3Wd 02u 03u 01u 0Nv 0Wu",
"0N 9 0.7",
"0Eu 1Wd 2Wd 3Wd 02u 03u 01u 0Sv 0Wu",
"01 d 1.4",
"01a 0Eb 02b 03b 1Wb 0Wv 12v 0Nu 0Su 1Nu 1Su 13v 1Ev",
"1N b 0.7",
"02d 03d 0Ed 1Wu 1Eu 13u 2Wd 3Wd 1Sv 01u 12u",
"1S b 0.8",
"02d 03d 0Ed 1Wu 1Eu 13u 2Wd 3Wd 1Nv 01u 12u",
"12 d 1.4",
"12a 13b 02b 1Eb 2Wb 01v 23v 1Nu 1Su 2Nu 2Su 1Wv 2Ev",
"2N b 0.7",
"13d 03d 0Ed 2Eu 2Wu 02u 1Ed 3Wd 2Sv 12u 23u",
"2S b 0.8",
"13d 03d 0Ed 2Eu 2Wu 02u 1Ed 3Wd 2Nv 12u 23u",
"23 d 1.4",
"23a 3Wb 13b 03b 2Eb 12v 3Ev 2Nu 2Su 3Nu 3Su 02v 2Wv",
"3N 9 0.7",
"3Wu 1Ed 2Ed 0Ed 13u 03u 3Sv 23u 3Eu",
"3S 9 0.8",
"3Wu 1Ed 2Ed 0Ed 13u 03u 3Nv 23u 3Eu",
"3E 6 1.0",
"23v 3Nu 3Su 13v 03v 3Wv"
};
