
/* octInterfaceInt.h --
 *        
 *     Denis Lee
 *     (Advising Professor - E. S. Kuh)
 *
 * Copyright (C) 1988 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header$
 */

#ifndef _OCT_INTERFACE_INT
#define _OCT_INTERFACE_INT /* once-only latch */


#define OCT_FIVE

#define OCT_PER_LAMBDA 20


/* ---------- Internal procedures for the octInterface module ---------- */

extern BearStatus BuildMacCell(/* parentCellPtr, cellInstPtrPtr, cellInstName,
                               xl, yb, xr, yt */);
/*
 * CellMaster  *parentCellPtr;
 * CellInst    **cellInstPtrPtr;
 * char *cellInstName;
 * int xl, yb, xr, yt;
 */

extern BearStatus BuildMacCellBoundary(/* xl, yb, xr, yt, cellInst */);
/*
 * int xl, yb, xr, yt;
 * CellInst  **cellInst;
 */

extern BearStatus BuildMacPin(/* cellMasterPtr, cellInst, termName, netName,
                              termX, termY */);
/*
 * CellMaster  *cellMasterPtr;
 * CellInst    *cellInst;
 * char *termName, *netName;
 * int termX, termY;
 */

extern octTransformType TransMagicToOct(/* trans */);
/*
 * Transform trans;
 */

#ifdef USE_DR_CODE
EXTERN BearStatus OdiWriteRoutingToOct
    ARGS((CellMaster *cellMasterPtr, octObject *chip));
#endif /* USE_DR_CODE */


/* --------- Internal global variables for the octInterface module --------- */

extern int  chip_xl, chip_yb, chip_xr, chip_yt;
extern char *odiOctHomePtr;


#endif _OCT_INTERFACE_INT

