
#include "bearIV.h"
#include "stdio.h"

static Display* ivBufDisplay;

#define IVRINGBELL( d ) { XBell ((d),50); XFlush( (d) ); }


void ivBufInit( buf, size, disp )
    ivBuf *buf;
    int size;
    Display* disp;
{
    buf->buf = (char*)malloc( (unsigned)size );
    if ( buf->buf != 0 ) {
	buf->size = size;
    } else {
	fprintf( stderr, "ivBuf: failed initialization: out of memory" );
    }
    ivBufDisplay = disp;
}

void ivBufClear( buf )
    ivBuf* buf;
{
    buf->count = 0;
    buf->buf[ 0 ] = '\0';
}

char* ivBufGetString( buf )
    ivBuf* buf;
{
    return buf->buf;
}

int ivBufGetLength( buf )
    ivBuf* buf;
{
    return buf->count;
}


void ivBufAddChar( buf, c )
    ivBuf* buf;
    char c;
{
    if (  buf->count + 2 <= buf->size  ) {
	buf->buf[ buf->count++ ] = c;
	buf->buf[ buf->count ] = '\0';
    } else {
	IVRINGBELL( ivBufDisplay );
    }
    buf->buf[ buf->count ] = '\0';
}

void ivBufAddString( buf, s )
    ivBuf* buf;
    char* s;
{
    int len = strlen( s );
    int i = buf->count;
    int size = buf->size;
    if ( buf->count + len < buf->size ) {
	strcpy( &buf->buf[ buf->count ] , s ) ;
	buf->count += len ;
    } else {
	IVRINGBELL( ivBufDisplay );
    }
}

void ivBufDelChar( buf )
    ivBuf* buf;
{
    if ( buf->count > 0 ) { 
	buf->count--;
    } else {
	IVRINGBELL( ivBufDisplay );
    }
    buf->buf[ buf->count ] = '\0';

}

void ivBufDelWord( buf )
    ivBuf* buf;
{
    /*
     * Erase the count word on the line.
     */
    do {
	ivBufDelChar( buf );
    } while ( buf->count > 0 && buf->buf[ buf->count - 1 ] != ' ' ); 
}
