
/* pbDialogs.h --
 *
 *     George Carvalho, Esq.
 *     Ben Chen
 *     (Advising Professor - E. S. Kuh)
 *
 * Copyright (C) 1988 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header$
 */

#ifndef _PB_DIALOGS
#define _PB_DIALOGS

extern void
PbAutoRoutePauseDialog(/* winDataPtr, checkConnFlag, keepGoingFlagPtr */);
/*
 * WindowData   *winDataPtr;
 * bool         checkConnFlag;
 * bool         *keepGoingFlagPtr;
 */

extern void PbCreateDialog(/* winDataPtr, screenPtr, argCount, argList */);
/* 
 * WindowData  *winDataPtr;
 * Point       *screenPtr;
 * int         argCount;
 * char        **argList;
 */

extern void PbDeleteDialog(/* winDataPtr, screenPtr, argCount, argList */);
/*
 * WindowData  *winDataPtr;
 * Point       *screenPtr;
 * int         argCount;
 * char        **argList;
 */

extern void PbDuplicateDialog(/* winDataPtr, screenPtr, argCount, argList */);
/* 
 * WindowData  *winDataPtr;
 * Point       *screenPtr;
 * int         argCount;
 * char        **argList;
 */

extern int PbTcDialog(/* index,argList,argCountPtr*/);
/* 
 * int index;
 * char **argList;
 * int *argCountPtr;
 */

#ifdef USE_OLDP_CODE
extern BearStatus PbClusterAlgDialog(/* parmsPtr */);
/*
 * ClParms *parmsPtr;
 */

extern BearStatus
PbClusterVarDialog(/* cellMasterPtr, parmsPtr, wireAdjust, modeFlag */);
/*
 * CellMaster  *cellMasterPtr;
 * ClParms     *parmsPtr;
 * double      wireAdjust;
 * bool        modeFlag;
 */

extern BearStatus
PbPlacerVarDialog(/* modePtr, modeValuePtr,
                   * defDimValue, defARValue, toValuePtr
                   */);
/*
 * char   *modePtr;            (* mode                        (OUT)      *)
 * double *modeValuePtr;       (* mode value                  (OUT)      *)
 * double defDimValue;         (* default dimension value     (IN)       *)
 * double defARValue;          (* default aspect ratio value  (IN)       *)
 * double *toValuePtr;         (* trade off value             (IN / OUT) *)
 */
#endif USE_OLDP_CODE

#ifdef USE_NEWP_CODE
extern BearStatus PbNewClusterAlgDialog();
extern BearStatus PbNewClusterVarDialog();
extern BearStatus PbNewPlacerVarDialog();
#endif USE_NEWP_CODE

extern BearStatus PbShapeOptDialog(/* parmsPtr */);
/*
 * So_UserParms *parmsPtr;
 */

extern BearStatus PbSteinerTreeDialog();
extern void       PbCpaDialog();
extern void       PbSetDebugFlags();

#endif _PB_DIALOGS

