
/* pbVersion.c --
 *
 *     George Carvalho
 *     (Advising Professor - E. S. Kuh)
 *
 */

#ifndef lint
static char rcsid[] = "$Header$";
#endif  not lint

#include "bearCopyRight.h"
#include <stdio.h>
#include "magic.h"
#include "malloc.h"
#include "geometry.h"
#include "tile.h"
#include "bear.h"
#include "fpg.h"
#include "gtGraph.h"
#include "tileProp.h"
#include "mac.h"
#include "ezPlot.h"
#include "polarBear.h"


/* ---------- Local Procedures ---------- */
static char *GetDateOfCompileTime();


static char *
GetDateOfCompileTime()
/*
 * Returns a string containing the date at which the program
 * was compiled.  It assumes that the date came from the program
 * `date'.
 */
{
#ifndef CUR_DATE
#define CUR_DATE "<compile date not supplied>"
#endif CUR_DATE

    static char result[25];

    char *datePtr = CUR_DATE;
    char day[10], month[10], zone[10];
    int date, hour, minute, second, year;

    if (sscanf (datePtr, "%s %s %2d %2d:%2d:%2d %s %4d",
        day, month, &date, &hour, &minute, &second, zone, &year) == 8) {

        (void) sprintf(result, "%d-%3s-%02d", date, month, year % 100);

        return (result);
    }
    else {
        return (datePtr);
    }
    /* NOTREACHED */
}


char *
PbGetVersion()
{
#ifndef BEAR_VERSION
#define BEAR_VERSION    "<version not supplied>"
#endif BEAR_VERSION

#ifdef BEAR_BLACK_BOX
#define NAME "BLACKBEAR"
#else
#define NAME "POLARBEAR"
#endif

    static char *versionPtr = NIL(char);

    if (versionPtr == NIL(char)) {
        (void) sprintf (bear_Msg, 
#if defined(__GNUC__)
          "UC Berkeley, %s Version %s (compiled %s with the GNU C compiler)\n",
#else
          "UC Berkeley, %s Version %s (compiled %s)\n",
#endif /* __GNUC__ */
            NAME, BEAR_VERSION, GetDateOfCompileTime());

        MALLOC(char *, versionPtr, (strlen (bear_Msg) + 1) * sizeof (char));
        strcpy(versionPtr, bear_Msg);
    }
    return (versionPtr);

#undef VERSION
}


