
/* routeDB.h --
 *
 *     Wei-Ming Dai
 *     (Professor E. S. Kuh)
 *
 * This file contains the heads of procedures which interface
 * with BBL routing data structure.  
 *
 * Copyright (C) 1987 Regents of the University of California
 * All rights reserved.
 *
 * needs: magic.h bear.h geometry.h localRouter.h 
 *
 * rcsid $Header: routeDB.h,v 1.3 87/02/09 11:56:34 weiming Exp $
 */

#ifndef _ROUTE_DB
#define _ROUTE_DB

#ifndef _MAGIC
int err0 = Need_to_include_magic_header;
#endif _MAGIC

#ifndef _BEAR
int err1 = Need_to_include_bear_header;
#endif _BEAR

#ifndef _GEOMETRY
int err2 = Need_to_include_geometry_header;
#endif _GEOMETRY

/*
#ifndef _LOCAL_ROUTER
int err3 = Need_to_include_localRouter_header;
#endif _LOCAL_ROUTER
*/

#include "rdbMain.h"
#include "rdbItr.h"
#include "rdbTrans.h"
#include "rdbShow.h"
#include "rdbMacBBL.h"
#include "rdbFree.h"

extern BearStatus Rdb_RouteChannelPass1(/* modPtr, rcellPtr, adjParPtr */);
/*
 * module       *modPtr;
 * RouteCell    *rcellPtr;
 * AdjPar       *adjParPtr;
 */

extern void Rdb_RouteChannelPass2(/* modPtr, rcellPtr, adjParPtr,
                                   * compactPar, viaReduceFlag
                                   */);
/*
 * module       *modPtr;
 * RouteCell    *rcellPtr;
 * AdjPar       *adjParPtr;
 * int          compactPar;
 * bool         viaReduceFlag;
 */

extern BearStatus Rdb_MacToBBL(/* rcellPtr, modPtrPtr */);
/*
 * RouteCell    *rcellPtr;
 * module       **modPtrPtr;
 */

extern BearStatus Rdb_ItrRSegmOfRRoot(/* rRootPtr, func, clientData */);
/*
 * root       *rRootPtr;
 * BearStatus (*func)();
 * ClientData clientData;
 */

extern BearStatus Rdb_WriteBBLFile();

/* ---------- External global variables for the routeDB module ---------- */
extern bool rdb_DebugFlag;

#endif _ROUTE_DB

