
/* shapeOptimizer.h --
 *
 *     (Advising Professor - E. S. Kuh)
 *
 * Definitions of the basic shapeOptimizer structures.
 * The definitions in this file are all that is visible to
 * the So (shapeOptimizer) modules.
 *
 * Copyright (C) 1988 Regents of the University of California
 * All rights reserved.
 *
 * Needs:
 *   magic.h
 *   geometry.h
 *   tile.h
 *   database.h
 *   tileProp.h
 *
 * sccsid @(#)shapeOptimizer.h    1.0 BEAR (Berkeley) 6/7/88
 */

#ifndef _SHAPEOPTIMIZER
#define _SHAPEOPTIMIZER

#define BEST_SLACK 0
#define HALF_SLACK 1
#define FULL_SLACK 2
#define ONE_D 0
#define TWO_D 1

typedef enum _SO_PlaneDirection PlaneDirection;
enum _SO_PlaneDirection {
    SO_VERT, SO_HORZ, SO_NONE
};

typedef enum so_Design {
    BBL, SC, GA
} Design;

typedef enum _SoStatus {
    SO_NOT_FINISHED,
    SO_FINISHED
} SoStatus;

typedef struct _ResizeData {
    CellInst        *cellInstPtr;
    Point           resize;
    Point           move;
    int             bnDensity;
    Tile            *bnTilePtr;
} ResizeData;

typedef struct _Slack {
    int             pos;
    int             neg;
} Slack;

typedef struct _SlackInfo {
    Slack           horzSlack;
    Slack           vertSlack;
} SlackInfo;

typedef struct _So_UserParms {
    PlaneDirection  prefDirect;
    Design          style;
    double          stopParm;
    int             gridSize;
    int             maxCnt;
    int             algorithm;
    int             option;
    char            *flexFileName;
} So_UserParms;


extern void         So_Init();
extern BearStatus   So_ReadShapeConstr();
extern BearStatus   So_DefineShapes();
extern SoStatus     So_ShapeOptimize();
extern void         So_ResizeCell();

#endif _SHAPEOPTIMIZER


