/* soInt.h --
 *
 *     Massoud Pedram
 *
 * This module performs shape optimization on a given initial placement.
 *
 * Copyright (C) 1988 Regents of the University of California
 * All rights reserved.
 */

#ifndef _SO_INT
#define _SO_INT

#include "bearCopyRight.h"
#include <stdio.h>
#include "magic.h"
#include "malloc.h"
#include "geometry.h"
#include "tile.h"
#include "bear.h"
#include "gtGraph.h"
#include "fpg.h"
#include "tileProp.h"
#include "mac.h"
#include "grEditor.h"
#include "tileMapping.h"
#include "deque.h"
#include "globalSpacer.h"
#include "shapeOptimizer.h"

#define HIST_PARM 5
#define SWITCH_OPT 8
#define MIN2(X,Y) ((X) < (Y) ? (X) : (Y))
#define MIN3(X,Y,Z) ((X) < MIN2((Y),(Z)) ? (X) : MIN2((Y),(Z)))

typedef struct _CritTileInfo
{
        Tile                *tilePtr;
        PlaneDirection      planeDir;
        int                 slk;
} CritTileInfo;

typedef struct _TileInfo
{
        Tile   *hPtr, *vPtr;
} TileInfo;

typedef enum _TransformType
{
        HtoV, VtoH, IDENTITY
} TransformType;

typedef struct _BNInfo
{
        Tile       *tilePtr;
        BNLine     *bnLinePtr;
        int        tileSpace;
        int        bnLineSpace;
        Rect       *searchRectPtr;
        TransformType transformType;
} BNInfo;


/* ---------- Declarations for global variables for so module ---------- */

extern LinkedTile  *soH1TileList, *soH2TileList;
extern LinkedTile  *soV1TileList, *soV2TileList;
extern PlaneData   *soGlobalPlaneDataPtr;
extern CellMaster  *soGlobalParentCellPtr;
extern char        soDebug;
extern bool        soQuit;
extern int         soCount;
extern double      soChipAreaArray[HIST_PARM];
extern double      soInitChipArea;

#endif _SO_INT

