
/* tmUnify.c --
 *
 *         Wei-Ming Dai
 *     (Professor E. S. Kuh)
 *
 * Main functions for tile unify.
 *
 */

#ifndef lint
static char rcsid[] = "$Header$";
#include "bearCopyRight.h"
#endif  not lint

#include <stdio.h>
#include "magic.h"
#include "malloc.h"
#include "geometry.h"
#include "tile.h"
#include "bear.h"
#include "gtGraph.h"
#include "fpg.h"
#include "tileProp.h"
#include "mac.h"
#include "tileMapping.h"


extern ViewType viewTypeFlag;


void
Tm_HUnifyNoFree(parentCellPtr)
CellMaster *parentCellPtr;
{
    PlaneData *planeDataPtr;

    planeDataPtr = Mac_GetCellPlaneOfCell(parentCellPtr);
    Tm_HFOnlyUnify(parentCellPtr, planeDataPtr);

    Tm_HBnUnify(parentCellPtr);
    viewTypeFlag = H_DONE;
}



void
Tm_HUnify(parentCellPtr)
CellMaster *parentCellPtr;
{
    PlaneData *planeDataPtr;

    planeDataPtr = Mac_GetCellPlaneOfCell(parentCellPtr);
    Tm_HFOnlyUnify(parentCellPtr, planeDataPtr);

    /*
     * Free pseudo pins on vertical tile plane here.
     */
    Tp_FreeAllPPinsOnVertPlane(planeDataPtr);

    Tm_HBnUnify(parentCellPtr);
    viewTypeFlag = H_DONE;
}



void
Tm_VUnifyNoFree(parentCellPtr)
CellMaster *parentCellPtr;
{
    PlaneData *planeDataPtr;

    planeDataPtr = Mac_GetCellPlaneOfCell(parentCellPtr);
    Tm_VFOnlyUnify(parentCellPtr, planeDataPtr);

    Tm_VBnUnify(parentCellPtr);
    viewTypeFlag = V_DONE;
}



void
Tm_VUnify(parentCellPtr)
CellMaster *parentCellPtr;
{
    PlaneData *planeDataPtr;

    planeDataPtr = Mac_GetCellPlaneOfCell(parentCellPtr);
    Tm_VFOnlyUnify(parentCellPtr, planeDataPtr);

    /*
     * Free pseudo pins on horizontal tile plane here.
     */
    Tp_FreeAllPPinsOnHorzPlane(planeDataPtr);

    Tm_VBnUnify(parentCellPtr);
    viewTypeFlag = V_DONE;
}



