
/* TileProp.h --
 *
 *     George Carvalho
 *     Wei-Ming Dai
 *     Andrew Purshottam
 *     June Wang
 *     (Professor E. S. Kuh)
 *
 * The tile property module is meant to complement the magic
 * data structures in the header file tile.h.  In particular for
 * solid tiles, the link to the corresponding cell instance,
 * dummy cell or routing cell; for a space tile, the capacity,
 * the density, and the psuedo pin lists of the tile.
 *
 * Copyright (C) 1986 Regents of the University of California
 * All rights reserved.
 *
 * needs: magic.h, geometry.h, mac.h
 *
 * rcsid $Header$
 */

#ifndef _TILEPROP
#define _TILEPROP

#ifndef _MAGIC
int err1 = Need_to_include_magic_header;
#endif _MAGIC

#ifndef _GEOMETRY
int err2 = Need_to_include_geometry_header;
#endif _GEOMETRY

#ifndef _TILES
int err3 = Need_to_include_tile_header;
#endif _TILES

#define TP_MOD_NAME "tileProp"

#include "bear.h"
#include "tpPPin.h"
#include "tpTile.h"
#include "tpTilePrim.h"
#include "tpTileItr.h"
#include "tpPaint.h"

/* ---------- External global variables for the tileProp module ---------- */
extern bool tp_DebugFlag;

#endif _TILEPROP

